program dcf77;
(*
  Aus CHIP 1991 heft 3 Seite 416
  Autor Dr. Rainer Decker
*)
uses dos,crt;
type
  DCFTyp = record
             bz:String[15];
             ps,ty,mx,mi:Integer;
           end;
const
  LenDCFTab=15;
  DCFDesc: array[1..LenDCFTab+1] of DCFTyp=
    ((Bz:'Unbenutzte Bits';PS:00;TY:0;MX:00;MI:0),
     (Bz:'Reserveantenne ';PS:15;TY:1;MX:01;MI:0),
     (Bz:'Anknd.Sommerz.';PS:16;TY:1;MX:01;MI:0),
     (Bz:'Sommerzeit     ';PS:17;TY:1;MX:01;MI:0),
     (Bz:'Resevebits     ';PS:18;TY:0;MX:03;MI:0),
     (Bz:'Start Zeitinfo ';PS:20;TY:2;MX:01;MI:1),
     (Bz:'Minute         ';PS:21;TY:3;MX:59;MI:0),
     (Bz:'Paritybit P1   ';PS:28;TY:4;MX:00;MI:0),
     (Bz:'Stunde         ';PS:29;TY:3;MX:23;MI:0),
     (Bz:'Paritybit P2   ';PS:35;TY:4;MX:29;MI:0),
     (Bz:'Kalendertag    ';PS:36;TY:3;MX:31;MI:1),
     (Bz:'Wochentag      ';PS:42;TY:3;MX:07;MI:1),
     (Bz:'Monat          ';PS:45;TY:3;MX:12;MI:1),
     (Bz:'Jahr           ';PS:50;TY:3;MX:99;MI:0),
     (Bz:'Paritybit P1   ';PS:58;TY:4;MX:36;MI:0),
     (Bz:'Stop:Kein Puls!';PS:59;TY:2;MX:00;MI:0));

  pp=$378;
  od=0;
  oi=1;
  os=2;
  DCFPulse=$10;
  DCFAktiv=$08;
  S01=24;
  Smin=200;

var
  Dauer0,Dauer1,
  PulseFlag,Divider,
  ADauer,AStat:Integer;
  ClockVect:Pointer;

  Sz:Integer;

  ab,pb:Boolean;

  DCFRes:Array[0..7] of Byte;

  DCFOk,
  DCFDone,
  DCFSet,
  DCFValid:Boolean;

  Std,min,sec,sec100:word;

  T0Rec,T1Rec:
  record
    lo,hi:Word
  end;
  T0:Longint absolute T0Rec;
  T1:Longint absolute T1Rec;

procedure DCFClear;
begin
  FillChar(DCFRes,Sizeof(DCFRes),0);
  pb:=False;
  sz:=0;
  DCFValid:=True;
  DCFOk:=False;
  DCFDone:=False;
end;

function BCDVal(bitct:Integer):Integer;
var
  res:Integer;
begin
  res:=1;
  while (bitct>4) do
  begin
    res:=res*10;
    bitct:=bitct-4;
  end;
  while (Bitct>1) do
  begin
    res:=res*2;
    dec(bitct);
  end;
  BCDVal:=res;
end;

function BITArray(p:Integer):Boolean;
begin
  BitArray:=((DCFRes[p div 8] shr (p mod 8)) and 1)>0;
end;

function BCD(p,l:Integer):Integer;
var
  bitct,res:Integer;
begin
  res:=0;
  bitct:=1;
  while l>0 do
  begin
    if (BitArray(p)) then res:=res+BCDval(bitct);
    inc(bitct);
    inc(p);
    dec(l);
  end;
  BCD:=res;
end;

function Parity(p,l:Integer):Boolean;
var
  res:Boolean;
begin
  res:=True;
  while l>0 do
  begin
    res:=res xor BitArray(p);
    inc(p);dec(l);
  end;
  Parity:=res;
end;

function BCDField(nr:Integer):Integer;
var
  res:integer;
  ok:Boolean;
begin
  with DCFDesc[nr] do
  begin
    res:=BCD(ps,DCFDesc[nr+1].ps-ps);
    case ty of
    0,1: ok:=true;
      2: ok:=(res=1);
      3: ok:=(res>=mi) and (res<=mx);
      4: ok:=parity(mx,ps-mx+1);
    end;
  end;

  if not ok then
  begin
    res:=res-1000;
    DCFOK:=False;
    Writeln('***Fehler**');
  end;
  BCDField:=res;
end;

procedure CallFar(p:Pointer);
const
  LocPtr :Pointer=nil;
begin
  if (P<>nil) then
  begin
    LocPtr:=p;
    inline($FF/$1E/LOcPtr);;
  end;
end;

procedure Clock_int; Interrupt;
begin
  if (port[pp+oi] and DCFPulse) <> AStat then
  begin
    AStat:=Port[pp+oi] and DCFPulse;
    If AStat=0 then
    begin
      Dauer0:=ADauer;
      PulseFlag:=1;
    end
    else
    begin
      Dauer1:=ADauer;
      PulseFlag:=PulseFlag or 2;
    end;
    ADauer:=0;
  end;
  inc(ADauer);
  inc(Divider);
  if (Divider=8) then
  begin
    CallFar(ClockVect);
    divider:=0;
   end
   else Port[$20]:=$20;
end;

procedure ClockInit;
begin
  Divider:=0;
  Dauer0:=0;
  Dauer1:=0;
  PulseFlag:=0;
  Adauer:=0;
  GetIntVec(8,ClockVect);
  SetIntVec(8,@Clock_Int);
  port[$43]:=$43;
  Port[$40]:=0;
  port[$40]:=$20;
  Astat:=0;
end;

procedure ClockDeInit;
begin
  SetIntVec(8,ClockVect);
  port[$43]:=$34;
  Port[$40]:=0;
  port[$40]:=0;
end;

procedure SetDosClock;
var h,mi,j,m,t:Integer;
   regs:Registers;
begin
    mi:=BCDField(7);
    h:=BCDField(9);
    regs.ch:=16*(h div 10) + (h mod 10);
    regs.cl:=16*(mi div 10) + (mi mod 10);
    regs.DX:=0;
    regs.ah:=3;
    repeat until PulseFlag>0;
    intr($1a,regs);

    SetTime(h,mi,0,0);
    j:=BCDField(14)+1900;
    if (j<1990) then j:=j+100;
    m:=BCDField(13);
    t:=BCDField(11);
    SetDate(j,m,t);

    gotoxy(0,23);
    writeln('PC-Uhr =',h,':',mi:2,'; ',t,'.',m,'.',j);

    DCFOk:=False;
    DCFDone:=true;
end;

procedure DCFEval;
var
  i,res:Integer;
begin
  if DCFValid then
  begin
    clrscr;
    SetDosClock;
    DCFOk:=True;
    DCFDone:=False;
    gotoxy(1,1);
    Writeln('DCF-Informationen:');
    for i:=1 to LenDCFTab do
    with DCFDesc[i] do
    begin
      res:=BCDField(i);
      if (ty in [1,3]) or (not DCFOk) then writeln(bz,':',res);
    end;
  end;
end;

begin
  clrscr;
  if (Port[pp+os] and DCFAktiv)=0 then
  begin
    Port[pp+os]:=port[pp+os] or DCFAktiv;
    writeln('1 s aus');
    delay(1000);
  end;
  DCFClear;
  port[pp+os]:=port[pp+os] and (not DCFAktiv);
  DCFSet:=(Paramstr(1)='S') or (ParamStr(1)='s');
  ClockInit;
  while not (keypressed or DCFDone) do
  begin
    case PulseFlag of
    1:
    begin
      sound(1000);
    end;
    3:begin
        GetTime(Std,min,sec,sec100);
        NoSound;
        if ((Dauer0+Dauer1)>Smin) then
        begin
          if (sz<>59) then
          begin
            gotoxy(71,1);write('Strung');
          end;
          DCFClear;
        end;

        ab:=Dauer1>s01;
        pb:=pb xor ab;
        PulseFlag:=0;

        asm
          mov ax,0
          int $1a
          mov T0Rec.hi,cx
          mov T0Rec.lo,dx
        end;

        gotoxy(70,1);
        write('DCF77',sz:3);
        Gotoxy(sz+10,24);
        if ab then write('1') else write('0');

        gotoxy(70,2);
        write(std:2,':',min:2,':',sec:2,',',sec100:2);

        gotoxy(70,3);write(T1-t0:9);
        t1:=t0;
        if ab then DCFRes[sz div 8]:=DCFRes[sz div 8] or (1 shl (sz mod 8));
        if (sz<60) then inc(sz);
        if (sz=59) then DCFEval;
      end;
    end;
  end;
  port[pp+os]:=port[pp+os] or DCFAktiv;
  ClockDeinit;
  Nosound;

  if not DCFDone then
    if DCFOk then halt(2)
    else halt(1);
end.