Unit meta0;
  (*
  *************************************************************
      Diese Unit enthlt die globalen Deklarationen fr META
  *************************************************************
  *)
Interface

Const
  ReleaseDate = '04.10.93';       (* Entwicklungsdatum *)
  (*
     Diese Konstanten werden vom Programm mit den Werten in
     META.PAR berschrieben.
  *)
  diff_lage : Real = 0.0100;      (* max. Differenz Lage I und II *)
  diff_ziel : Real = 0.0050;      (* max. Diferenz Satz 1-4 *)
  diff_index : Real = 0.05;       (* max. zul. Indexfehler gon *)
  max_v : Real = 0.002;           (* max. zul. Indexverbesserung gon *)
  delta_EF : Real = 0.118;        (* Abstand EDM-Fernrohr *)
  Akkuzeit : Integer = 220;       (* Akkukapazitt min *)
  T2000_Flag : Boolean = True;    (* T2000 ja/nein-Flag *)
  aufsatzEDM : Boolean = True;    (* Aufsatz EDM-Gert *)
  StreckenOnline : Boolean = True; (* Online Streckenmessung ? *)
  (* Konstanten fr die Druckersteuerung
    OKI ML182
  *)
  uli_on : String[24] = #22'-'#1; (* Unterstreichen ein *)
  uli_off : String[24] = #27'-'#0; (* Unterstreichen aus *)
  fett_on : String[24] = #27'E';  (* Fettschrift ein *)
  fett_off : String[24] = #27'F'; (* Fettschrift aus *)
  sperr_on : String[24] = #14;    (* Breitschrift ein *)
  sperr_off : String[24] = #20;   (* Breitschrift aus *)
  cond_on : String[24] = #27':';  (* Schmalschrift ein *)
  cond_off : String[24] = #18;    (* Schmalschrift aus *)
  (* Konstanten zur Programmdimensionierung *)

  max_Station = 1000;             (* max. Standpunktzahl/Datei *)
  max_Richtung = 20;              (* max. Richtungen pro Standpunkt *)
  max_Satz = 3;                   (* max. Satzzahl pro Richtung *)
  max_IO_Felder = 70;             (* max. IO-felder *)
  max_Geraet = 10;                (* max. Geraetedaten *)
  max_Signal = 30;                (* max. Signaldaten *)


  T2000_Code : Real = 0;          (* T2000 Codewort *)
  ComPort : Byte = 0;             (* Kommunikationsport COM1 *)
  ErstRichtung : Integer = 0;     (* Richtungsmerker *)
  ins_Flag : Boolean = False;     (* Insert Flag *)
  Drucker_Flag : Boolean = False; (* Drucker_flag *)
  Blinken : Boolean = False;      (* Blinkend Anzeigen *)
  StartFlag:Boolean = True;       (* Startflag fr ParmStr setzen *)

  max_ri = 3;                     (* max . Richtungen pro Bildschirm *)
  maxWindow = 9;                  (* max. 10 berlappende Fenster *)

  EDMTypen = 'DIHPGM';            (* Zulssige EDM-Typen *)


  Hell = 8;
  Blink = $80;

  (* Konstanten fr die Textdatei IO *)

  fmClosed = $D7B0;
  fmInput = $D7B1;
  fmOutput = $D7B2;
  fmInOut = $D7B3;

  (* Konstante fr Berechnunggen *)
  MaxPdat = 2000;                 (* Maximale Punktanzahl *)
  SuchBeo : Boolean = True;       (* Flag fr Beobachtungen suchen *)
  Protokoll : Boolean = False;    (* Flag fr Protokolldatei *)
  AutoHoehe : Boolean = True;     (* Flag fr Automatische Hhenberechnung *)
  Speichervoll = 'Punktspeicher ist voll!';
  InternalSW:Boolean=False;       (* Flag fr Verwendung der METASW *)


Type
  (* Diverse Stringtypen *)

  str2 = String[2];
  str4 = String[4];
  str3 = String[3];
  str5 = String[5];
  str6 = String[6];
  str8 = String[8];
  str10 = String[10];
  str12 = String[12];
  str14 = String[14];
  str15 = String[15];
  str16 = String[16];
  str40 = String[40];
  str80 = String[80];
  str128 = String[128];
  str255 = String;
  (* Bildschirm *)
  picture = Array[1..25, 1..80] Of Word;

  (* Struktur T2000 Messung *)
  T2000_typ = Record
                P : str8;         (* T2000-Punktnummer *)
                r : Real;         (* T2000-Richtung *)
                z : Real;         (* T2000-Zenitdistanz *)
                d : Real;         (* T2000-Schrgentfernung *)
              End;

  (* Struktur Eingabefeld *)
  msk_par_typ = Record
                  io : Char;      (* IO-Typ I/O *)
                  opt : Char;     (* Option A,a,U,N,P,T *)
                  y : Byte;       (* Zeile *)
                  x : Byte;       (* Spalte *)
                  l : Byte;       (* Lnge *)
                  komma : Byte;   (* Kommastellen *)
                End;
  (* zulssige Sondertasten *)
  msk_rev_typ = (ESC, RET, Up, Down, PgUp, PgDown, F1, F2, F3, F4, F5, F6);

  (* Lnge der Punktnummer *)
  Punkt_typ = String[10];
  (* Selektoren fr variante Records *)
  Satz_typ = (Auftrag, Geraet, Station, Ziel, Azimut1, Azimut2, Azimut3, Polynom);

  (* Struktur Auftragsdaten *)
  Auftrag_typ = Record
                  Aktenz : String[12]; (* Aktenzeichen *)
                  Arb_Plan : String[12]; (* Arbeitsplan Nummer *)
                  Gemarkung : String[25]; (* Gemarkungsname *)
                  Beobachter : String[25]; (* Name des Beobachters *)
                  LVBernr : Word; (* LV-Berechnungsnummer *)
                  MetaBernr : Word; (* META-Berechnungsnummer *)
                  (* Blattnummer TK25 *)
                  TK25 : Array[1..10] Of Word;
                End;
  (* Struktur Signaldaten *)
  Signal_typ = Record
                 bp : Punkt_typ;  (* Punktnummer *)
                 r0 : Real;       (* Nullrichtung *)
                 h0 : Real;       (* Nullhhe *)
                 Hub : Real;      (* Hub *)
                 Al : Real;       (* Schwenkbereich *)
               End;

  (* Struktur Gertedaten *)
  Geraet_typ = Record
                 Index : Byte;    (* Gerteindex 1-max_Gert *)
                 Nummer : String[12]; (* Gertenummer *)
                 Name : String[25]; (* Gertebezeichnung *)
                 Kennung : String[2]; (* Kennung MB,GM,BL.HP.. *)
                 A, B, C, d : Real; (* Gertekonstanten *)
                 (* Signalkonstanten *)
                 Sig : Array[1..3] Of Signal_typ;
               End;
  (* Struktur Standpunkt *)
  Station_typ = Record
                  Ps : Punkt_typ; (* Standpunktnummer *)
                  Pfeiler : String[5]; (* HO/HU/Pfeilerlnge *)
                  p_ps : Real;    (* mm HG im Standpunkt *)
                  Tag : Real;     (* Tagesdateum TTMMJJ *)
                  Zeit : Real;    (* Uhrzeit *)
                  Bem : String[30]; (* Standpunktbemerkung *)
                  Richtungen : Byte; (* Zahl der Richtungen *)
                  Saetze : Byte;  (* Zahl der Stze *)
                  Zeilen : ShortInt; (* Zahl der Ziele *)
                  mr : Real;      (* mittl. Richtungsfehler *)
                End;

  (* Struktur Zielpunkt *)
  Ziel_typ = Record
               Pz : Punkt_typ;    (* Zielpunktnummer *)
               tt : Real;         (* Trockentemperatur *)
               tf : Real;         (* Feuchttemperatur *)
               p_Pz : Real;       (* mm HG fr die Strecke *)
               Bem : String[15];  (* Zielpunktbemerkung *)
               Ri : Array[0..max_Satz, 1..3] Of Real;
               (* gemessene Richtungen *)
               rm : Real;         (* Satzmittel *)
               zd : Real;         (* gemittelte Zenitdistanz *)
               z1, z2,
               z3, z4 : Real;     (* Zenitdistanzmessungen *)
               zi, zv : Real;     (* Indexfehler,Verbesserung *)
               F, T,
               E, r : Real;       (* Fernrohr,Tafel,EDM,Refl *)
               S : Real;          (* reduzierte Strecke *)
               seitw,
               exz : Real;        (* seitwrts, Exzentrizitt *)
               d : Real;          (* Schrgstrecke *)
               MG : Byte;         (* Gerteindex *)
               dH : Real;         (* Hhenunterschied *)
             End;

  Azimut1_Typ =
    Record
      Ps : Punkt_typ;
      YS, XS, HS, LS, BS, cS : Real;
      Pz : Punkt_typ;
      YZ, XZ, HZ, LZ, BZ, cZ : Real;
      Bem : String[20];
      Datum : Real;
      t1, t2, tm : Real;
    End;

  Azimut2_typ =
    Record
      Druck, Temp : Real;
      MG : Byte;
      F, T, E, r, S, d, dH : Real;
      z, z1, z2, z3, z4 : Real;
    End;

  Azimut3_typ =
    Record
      RZ, MEZSoll, UhrIst, DeltaU : Real;
      RH : Array[1..5] Of Record
                            Rand : Char;
                            Ri, Uhr, MEZ, ti, v : Real;
                          End;
    End;

  (* Struktur der Beobachtungsdatei *)
  Beob_typ = Record
               Case art : Satz_typ Of
                 Auftrag : (Au : Auftrag_typ);
                 Geraet : (Ge : Geraet_typ);
                 Station : (St : Station_typ);
                 Ziel : (zi : Ziel_typ);
                 Azimut1 : (Az1 : Azimut1_Typ);
                 Azimut2 : (Az2 : Azimut2_typ);
                 Azimut3 : (Az3 : Azimut3_typ);
             End;

  (* Fenstertyp *)
  windowtyp = Array[1..2000] Of Word;
  (* Rechnerstak *)
  stak_typ = Record
               x, y, z, T, lastx : Real;
             End;
  (* Punktzeigerstruktur *)
  zeiger_typ = Record
                 pkt : Punkt_typ;
                 rec : Word;
                 Art : Char;
               End;
  (* Lst Gert *)
  TextBuf = Array[0..127] Of Char;
  TextRec = Record
              Handle : Word;
              Mode : Word;
              BufSize : Word;
              Private : Word;
              BufPos : Word;
              BufEnd : Word;
              BufPtr : ^TextBuf;
              OpenProc : Pointer;
              OutProc : Pointer;
              FlushProc : Pointer;
              CloseProc : Pointer;
              UserData : Array[1..16] Of Byte; { um 4 Bytes kleiner }
              Name : Array[0..79] Of Char;
              Buffer : TextBuf;
            End;

  (* Punktstruktur *)
  VermPunkt_Typ = Record
                    P : Punkt_typ;
                    y, x, HO, HU : Real;
                  End;
  (*
  ****************************************************************
                    Globale Variable
  ****************************************************************
  *)

Var
  ChecksumExe, ChecksumOVR : LongInt; (* Virenschutz *)
  ExitSave : Pointer;             (* Zeiger auf Original Exit-Prozedur *)
  max_Felder, feld : Byte;        (* IO-Feldzhler *)
  Richtung : Integer;             (* aktuelle Richtung *)
  msk_inp : str80;                (* IO-Variable *)
  msk_val : Real;                 (* IO-Variable *)
  msk_rev : msk_rev_typ;          (* IO-Abbruchinformation *)
  Filename : String[25];          (* Dateiname *)
  msk_par : Array[1..max_IO_Felder] Of msk_par_typ;
  (* IO-Parameter *)
  Standpunkt : Station_typ;       (* Standpunkt *)
  Zielpunkt : Array[0..max_Richtung] Of Ziel_typ;
  Azi1 : Azimut1_Typ;
  Azi2 : Azimut2_typ;
  Azi3 : Array[1..2] Of Azimut3_typ;
  (* Zielpunkte *)
  Satz_Art : Satz_typ;            (* Satz-descriptor *)
  Buffer : Beob_typ;              (* Dateipuffer *)
  Datei : File Of Beob_typ;       (* Dateivariable *)
  ZeigerFile : File Of zeiger_typ;
  merk_rec : Word;                (* Satzmerker fr gespeicherte Stationen *)
  new_Display : Boolean;          (* Maske neu aufbauen J/N *)
  Projekt : String[40];           (* Projektname *)
  T2000 : T2000_typ;              (* T2000-Messdaten *)
  monochrom : Boolean;            (* Bildschirmflag *)
  screen : ^picture;              (* Bildschirmzeiger *)
  Fenster : Array[0..maxWindow] Of ^windowtyp;
  (* Fensterzeiger *)
  FensterNr : Byte;               (* aktuelles Fenster *)
  bt : Array[1..max_Signal] Of Signal_typ;
  PunktZeiger : Array[1..max_Station] Of zeiger_typ;
  (* Standpunktzeiger *)
  GeraeteTyp : Array[0..max_Geraet] Of String[2];
  GerKonst : Array[0..max_Geraet] Of Record N0, NG, C : Real; End;
  stationen : Word;               (* Anzahl gespeicherter Standpunkte *)
  lst, auxout, auxinp : Text;     (* Text IO Variable *)

  Pdat : Array[0..MaxPdat] Of ^VermPunkt_Typ;
  (* Array mit Punkten *)
  MaxP : Word;                    (* Anzahl der gespeicherten Punkte *)
  YGebiet, Hgebiet : Real;        (* Mittlere Rechtswerte und Hhen *)
  Prot : Text;                    (* Protokolldatei *)
Implementation

Begin
End.
