Unit meta1;
Interface
Uses Dos, CRT, meta0, AuxIO;

Function sgn(x : Real) : Integer;
Function arcsin(x : Real) : Real;
Function arccos(x : Real) : Real;
Function power(x, y : Real) : Real;
Function tan(x : Real) : Real;
Procedure R_P(Var dy, DX : Real);
Function UpcaseStr(x : String) : String;
Function Val_from_Str(inp : str80) : Real;
Function ConstStr(n : Byte; C : Char) : str255;
Procedure cursor(typ : Byte);
Procedure scroll(Var zei : Byte; von, bis, links, rechts, anz : Byte);
Procedure write_Screen(spalte, zeile : Integer; Text : str80; Vordergrund, Hintergrund : Byte);
Procedure write_screen_real(spalte, zeile, len, dez : Integer; x : Real; Vordergrund, Hintergrund : Byte);
Procedure write_screen_int(spalte, zeile, len, x : Integer; Vordergrund, Hintergrund : Byte);
Procedure save_Window(x1, y1, x2, y2 : Byte);
Procedure open_Window(x1, y1, x2, y2 : Byte; Forgrd, Backgrd : Byte);
Procedure close_Window(x1, y1, x2, y2 : Byte);
Procedure Beep;
Procedure Siren;
Function set_ri(x : Byte) : Byte;
Procedure melde(meldung : str80);
Procedure warten(n : Byte);
Function JaNein(frage : str80) : Boolean;
Procedure UserError;
Procedure get_datum(Var Tag : str8; Var Name : str2; Var Zeit : Real);
Function hms_h(x : Real) : Real;
Function h_hms(x : Real) : Real;
Function ATM(d, tt, P : Real; MG : Byte) : Real;
Procedure set_T2000;
Function lies_T2000 : Boolean;
Procedure T2000_ein;
Procedure T2000_aus;
Procedure Formular_Maske;
Procedure Auftrag_Maske;
Procedure Geraet_Maske;
Procedure Projekt_Maske;
Procedure Azimut_Maske;
Procedure Polynom_Maske;

Implementation

  Function sgn(x : Real) : Integer;
    (* Eingabe: Realvariable x
       Ausgabe: Integerwert  0 : x=0 ,1 : x>0, -1 : x<0
    *)
  Begin
    sgn := 0;
    If x < 0 Then sgn := -1 Else sgn := 1;
  End;

  Function arcsin(x : Real) : Real;
  Begin
    If Abs(x) = 1 Then arcsin := sgn(x)*Pi/2
    Else arcsin := ArcTan(x/Sqrt(1-x*x));
  End;

  Function arccos(x : Real) : Real;
  Begin
    If x = 0 Then arccos := Pi/2
    Else
      If x < 0 Then arccos := Pi+ArcTan(Sqrt(1-x*x)/x)
    Else arccos := ArcTan(Sqrt(1-x*x)/x);
  End;

  Function power(x, y : Real) : Real;
  Begin
    power := 1.0;
    If x = 0.0 Then
      If y = 0.0 Then power := 1.0
      Else power := 0.0
    Else
      If y = 0.0 Then power := 1.0;
    If x > 0.0 Then
      If y > 0.0 Then power := Exp(y*Ln(Abs(x)))
      Else power := Exp(-Abs(y)*Ln(Abs(x)));
  End;

  Function tan(x : Real) : Real;
  Begin
    If Cos(x) = 0 Then tan := 1E29*sgn(Cos(x)) Else tan := Sin(x)/Cos(x);
  End;

  Procedure R_P(Var dy, DX : Real);
  Var
    S, T : Real;
  Begin
    If DX = 0 Then T := sgn(dy)*Pi/2
    Else T := ArcTan(dy/DX);
    If DX < 0 Then T := T+Pi;
    If T < 0 Then T := T+Pi+Pi;
    S := Sqrt(dy*dy+DX*DX);
    If (DX = 0) And (dy = 0) Then T := 0;
    DX := S; dy := T;
  End;

  Function UpcaseStr(x : String) : String;
  Var i : Integer;
  Begin
    For i := 1 To Length(x) Do x[i] := Upcase(x[i]);
    UpcaseStr := x;
  End;

  Function Val_from_Str(inp : str80) : Real;
  Var i : Integer;
    x : Real;
  Begin
    If inp = '' Then inp := '0';
    While (Length(inp) > 0) And (inp[1] <= #32) Do Delete(inp, 1, 1);
    While (Length(inp) > 0) And
    ((inp[Length(inp)] <= #32) Or (inp[Length(inp)] = '.')) Do
      inp := Copy(inp, 1, Pred(Length(inp)));
    If inp[1] = '.' Then inp := '0'+inp;
    If (inp[1] = '-') And (inp[2] = '.') Then Insert('0', inp, 2);
    If Length(inp) = 0 Then Val_from_Str := 0
    Else
    Begin
      Val(inp, x, i);
      If i = 0 Then Val_from_Str := x Else
      Begin
        Val_from_Str := 0;
      End;
    End;
  End;

  Function ConstStr(n : Byte; C : Char) : str255;
    (* liefert String aus n Zeichen C *)
  Var S : String;
  Begin
    S[0] := Chr(n);
    FillChar(S[1], n, C);
    ConstStr := S;
  End;


  Procedure teste_bildschirm;
  Var Reg : registers;
  Begin
    Reg.ah := $0f;
    Intr($10, Reg);
    If Reg.Al = 7 Then
    Begin
      screen := Ptr($B000, 0); monochrom := True;
    End
    Else
    Begin
      screen := Ptr($B800, 0); monochrom := False;
    End;
  End;

  Procedure cursor(typ : Byte);
    (* typ 0 = Cursor aus
    typ 1 = Cursor normal ein
    typ 2 = Blockcursor ein
    *)

  Var regs : registers;
  Begin
    With regs Do
    Begin
      ax := $0100;
      Case typ Of
        0 : cx := $2000;
        1 : If monochrom Then cx := 13+(12 Shl 8) Else cx := 7+(6 Shl 8);
        2 : cx := 12;
        3 : Begin
              Ch := 6; cl := 3;
            End
      Else cx := 13+(12 Shl 8);
      End;
    End;
    Intr($10, regs);
  End;

  Procedure scroll(Var zei : Byte; von, bis, links, rechts, anz : Byte);
    (* Bildschirmausschnitt um anz Zeilen rollen *)
  Var regs : registers;
    cs_anf, cs_end : Byte;
  Begin
    (* Cursor sichern und abschalten *)
    regs.ah := 3; regs.bh := 0; Intr($10, regs);
    cs_anf := regs.Ch; cs_end := regs.cl;
    cursor(0);
    (* Aufwrts rollen *)
    If zei > bis Then
    Begin
      regs.ah := 6; regs.Al := anz;
      regs.bx := 0;
      regs.Ch := Pred(von); regs.dH := Pred(bis);
      regs.cl := Pred(links); regs.dl := Pred(rechts);
      Intr($10, regs);
      GoToXY(links, bis);
      zei := bis;
    End;
    (* Abwrts rollen *)
    If zei < von Then
    Begin
      regs.ah := 7; regs.Al := anz;
      regs.bx := 0;
      regs.Ch := Pred(von); regs.dH := Pred(bis);
      regs.cl := Pred(links); regs.dl := Pred(rechts);
      Intr($10, regs);
      GoToXY(links, von);
      zei := von;
    End;
    (* Cursor herstellen *)
    regs.ah := 1; regs.Ch := cs_anf; regs.cl := cs_end;
    Intr($10, regs);
  End;

  Procedure write_Screen(spalte, zeile : Integer; Text : str80; Vordergrund, Hintergrund : Byte);
    (* Schnelle Bildchirmausgabe *)

  Var attb : Word;
    i : Byte;
  Begin
    If Blinken Then Vordergrund := Vordergrund+Blink;
    attb := Word((Hintergrund Shl 4+Vordergrund) Shl 8);
    i := 0;
    While (i < Length(Text)) And ((i+spalte) <= 80) Do
    Begin
      Inc(i);
      screen^[zeile, Pred(spalte)+i] := Ord(Text[i])+attb;
    End;
  End;

  Procedure write_screen_real(spalte, zeile, len, dez : Integer; x : Real; Vordergrund, Hintergrund : Byte);
    (* Realwert ausgeben *)
  Var S : str80;
  Begin
    Str(x:len:dez, S);
    write_Screen(spalte, zeile, S, Vordergrund, Hintergrund);
  End;

  Procedure write_screen_int(spalte, zeile, len, x : Integer; Vordergrund, Hintergrund : Byte);
    (* Integer ausgeben *)
  Var S : str80;
  Begin
    Str(x:len, S);
    write_Screen(spalte, zeile, S, Vordergrund, Hintergrund);
  End;

  Procedure save_Window(x1, y1, x2, y2 : Byte);
    (* Bildschirmfenster sichern *)
  Var i, j : Byte;
    k : Integer;
  Begin
    Inc(FensterNr);
    GetMem(Fenster[FensterNr], Succ(x2-x1)*Succ(y2-y1)*2);
    k := 0;
    For i := y1 To y2 Do
      For j := x1 To x2 Do
      Begin
        Inc(k);
        Fenster[FensterNr]^[k] := screen^[i, j];
      End;
  End;

  Procedure open_Window(x1, y1, x2, y2 : Byte; Forgrd, Backgrd : Byte);
    (* Fenster ffnen *)
  Const oli = #201; ore = #187; ure = #188; uli = #200; vert = #186; hor = #205;
  Var i : Byte;
  Begin
    save_Window(x1, y1, x2, y2);
    write_Screen(x1, y1, oli, Forgrd, Backgrd);
    write_Screen(x2, y1, ore, Forgrd, Backgrd);
    write_Screen(x2, y2, ure, Forgrd, Backgrd);
    write_Screen(x1, y2, uli, Forgrd, Backgrd);
    For i := Succ(x1) To Pred(x2) Do
    Begin
      write_Screen(i, y1, hor, Forgrd, Backgrd);
      write_Screen(i, y2, hor, Forgrd, Backgrd);
    End;
    For i := Succ(y1) To Pred(y2) Do
    Begin
      write_Screen(x1, i, vert, Forgrd, Backgrd);
      write_Screen(Succ(x1), i, ConstStr(Pred(x2)-x1, ' '), Forgrd, Backgrd);
      write_Screen(x2, i, vert, Forgrd, Backgrd);
    End;
  End;

  Procedure close_Window(x1, y1, x2, y2 : Byte);
    (* Fenster schlieen *)
  Var i, j : Byte;
    k : Integer;
  Begin
    k := 0;
    For i := y1 To y2 Do
      For j := x1 To x2 Do
      Begin
        Inc(k);
        screen^[i, j] := Fenster[FensterNr]^[k];
      End;

    FreeMem(Fenster[FensterNr], Succ(x2-x1)*Succ(y2-y1)*2);
    Dec(FensterNr);
  End;

  Procedure Beep;
  Begin
    Sound(1000); Delay(100);NoSound;
  End;

  Procedure Siren;
  Var i : Integer;
  Begin
    For i := 1 To 5 Do
    Begin
      Sound(800); Delay(40);
      Sound(1000); Delay(50);
    End;
    NoSound;
  End;

  Function set_ri(x : Byte) : Byte;
    (*
    Displayzeile fr Bildschirformular berechnen
    Eingabe : Zeile im Richtungsblock
    Ausgabe : Displayzeile
    *)
  Var y, r : Byte;
  Begin
    If Richtung >= 0 Then r := Richtung Else r := 0;
    y := x+5*(r-ErstRichtung);
    (* Bis Richtung aufwrts rollen *)
    While r-ErstRichtung >= max_ri Do
    Begin
      Inc(ErstRichtung);
      scroll(y, 9, 22, 2, 79, 5);
    End;
    (* Bis Richtung abwrts rollen *)
    While r-ErstRichtung < 0 Do
    Begin
      Dec(ErstRichtung);
      scroll(y, 9, 22, 2, 79, 5);
    End;
    set_ri := x+5*(r-ErstRichtung);
  End;

  Procedure melde(meldung : str80);
    (* Anzeigen einer Meldung *)
  Begin
    write_Screen(1, 25, ConstStr(80, ' '), LightRed, Black);
    write_Screen(1, 25, meldung, LightRed, Black);
    GoToXY(Succ(Length(meldung)), 25);
  End;

  Procedure warten(n : Byte);
    (* n sec Abwarten *)
  Begin
    Delay(n*1000)
  End;

  Function JaNein(frage : str80) : Boolean;
    (* Ja/Nein Abfrage in der aktuellen Meldezeile *)
  Var jn : Char;
    x, y : Integer;
  Begin
    frage := frage+' J/N  ?';
    y := Length(frage)+3; x := (80-y) Div 2;
    open_Window(x, 11, x+y, 13, LightRed, Black);
    Repeat
      write_Screen(x+2, 12, frage, LightRed, Black); Beep;
      GoToXY(x+y-2, 12);
      cursor(2);
      jn := Readkey; jn := Upcase(jn); Write(jn);
      cursor(0);
    Until jn In ['J', 'N'];
    JaNein := jn = 'J';
    close_Window(x, 11, x+y, 13);
  End;

procedure Melody(nr:integer);
Const C = 262; D = 294; E = 329; F = 349; G = 392; A = 440;
      H = 494; Cc = 523; P = 0;
      T2 = 800; T3 = 600; T4 = 400; T6 = 300; T8 = 200; T16 = 100;
      fis =370; dd= 587; ee=659;
      Max = 68;

Type Musik = (Hoehe, Laenge);
     Liedtyp = array[Musik, 1..Max] of Word;

const Lied : Liedtyp =
      ((g,g,a,g,cc,h,a,g,f,f,e,e,d,c,d,e,p,
        g,g,a,g,cc,h,a,g,f,f,e,e,g,f,d,c,
        p,e,d,e,d,g,d,g,h,a,a,g,g,fis,g,a,g,p,
        g,g,a,g,cc,h,a,g,ee,dd,dd,cc,cc,h,a,h,cc),

       (t8,t6,t16,t8,t8,t8,t8,t3,t4,t8,t4,t8,t8,t8,t8,t2,t8,
        t8,t6,t16,t8,t8,t8,t8,t3,t4,t8,t4,t8,t8,t8,t8,t2,
        t8,t8,t6,t16,t8,t8,t8,t8,t3,t4,t8,t4,t8,t8,t8,t8,t2,
        t8,t8,t6,t16,t8,t8,t8,t8,t4,t8,t4,t8,t4,t8,t8,t8,t8,t2));


Var Note : Byte;
Begin
  For Note := 1 to 17 do
    begin
     Sound(Lied[hoehe,note]);
     delay(Lied[laenge, note]);
     nosound;
     Delay(50);
    end;
  Siren;
end;

  Procedure UserError;
  Const
    fehlmeld : Array[0..11] Of String[30] =
    ('mindestens 0,92 Promille',
     'was soll das bedeuten',
     'Nikolausi',
     'dicht vorbei ist auch daneben',
     'nur Mut, es wird schon',
     'Mahlzeit',
     'selbst oagschmiert',
     'i mag nit',
     'Osterhasi',
     'gr dich',
     'abwarten und zuschlagen',
     'take it easy');

  Var
    i : Integer;
  Begin
    Randomize;
    i := Random(12);
    open_Window(22, 11, 28+Length(fehlmeld[i]), 13, LightRed, Black);
    write_Screen(23, 12, '...'+fehlmeld[i]+'!', LightRed, Black);
    (*
    melody(0);
    *)
    close_Window(22, 11, 28+Length(fehlmeld[i]), 13);
  End;

  Function hms_h(x : Real) : Real;
    (* Eingabe: Grad.MinutenSekunden
       Ausgabe: Dezimalaltgrad
    *)
  Var y : Real;
    minus : Boolean;
  Begin
    minus := x < 0; x := Abs(x);
    y := Int(x);
    x := Int(Frac(x)*1E6+0.5)/1E4;
    y := y+Int(x)/60;
    x := Int(Frac(x)*1E6+0.5)/1E4;
    y := y+x/3600;
    If minus Then hms_h := -y Else hms_h := y;
  End;

  Function h_hms(x : Real) : Real;
    (* Eingabe: Dezimalaltgrad
       Ausgabe: Grad.MinutenSekunden
    *)
  Var h, m, S : Real;
    minus : Boolean;
  Begin
    minus := x < 0; x := Abs(x);
    h := Int(x); x := Int(Frac(x)*1E6+0.5)/1E6*60;
    m := Int(x); S := Int(Frac(x)*1E6+0.5)/1E6*60;
    h := h+m/1E2+S/1E4;
    If minus Then h_hms := -h Else h_hms := h;
  End;

  Procedure get_datum(Var Tag : str8; Var Name : str2; Var Zeit : Real);
  Const wochentag : Array[0..6] Of str2 =
    ('So',
     'Mo',
     'Di',
     'Mi',
     'Do',
     'Fr',
     'Sa');

  Var regs : registers;
    x : String[8];
  Begin
    With regs Do
    Begin
      ax := $2a00;
      MsDos(regs);
      Str(((cx-1900)+Hi(DX)*1E2+Lo(DX)*1E4):6:0, x);
      Tag := Copy(x, 1, 2)+'.'+Copy(x, 3, 2)+'.'+Copy(x, 5, 2);
      Name := wochentag[Al];
      ax := $2c00;
      MsDos(regs);
      Zeit := Int(Ch)+cl/1E2+dH/1E4;
    End;
  End;

  Function ATM(d, tt, P : Real; MG : Byte) : Real;
  Const
    Rad = 6381438.5;
  Var tf, Ew, modul, k1, k2, x : Real;
  Begin
    tf := 273.16+tt; modul := 1.0/Ln(10); x := 373.16/tf;
    Ew := -7.90298*(x-1)+5.02808*Ln(x)*modul
    -1.3816E-7*(power(10, 11.344*(1-1/x))-1)
    +8.1328E-3*(power(10, -3.49149*(x-1))-1)
    +Ln(1013.25)*modul;
    If Ew < 0 Then Ew := 0.7501/power(10, -Ew)
    Else Ew := 0.7501*power(10, Ew);
    k1 := (GerKonst[MG].N0-GerKonst[MG].NG/(273.16+tt)*P/760+15/(273.16+tt)*Ew)*d*1E-6;
    k2 := 0.7569*d*d*d/24/Rad/Rad;
    ATM := k1+k2;
  End;

  Procedure LStOutChar(C : Char);
  Var regs : registers;
  Begin
    If Drucker_Flag Then
    Begin
      regs.ah := 05; regs.dl := Ord(C); MsDos(regs);
    End
  End;

{$F+}
  Function LstOutput(Var F : TextRec) : Integer;
  Var
    P : Integer;
  Begin
    With F Do
    Begin
      If BufPos > 0 Then
        For P := 0 To Pred(BufPos) Do LStOutChar(BufPtr^[P]);
      BufPos := 0;
    End;
    LstOutput := 0;
  End;

  Function LstIgnore(Var F : TextRec) : Integer;
  Begin
    LstIgnore := 0;
  End;

  Function LstOpen(Var F : TextRec) : Integer;
  Begin
    With F Do
    Begin
      Mode := fmOutput;
      OutProc := @LstOutput;
      FlushProc := @LstOutput;
      CloseProc := @LstIgnore;
    End;
    LstOpen := 0;
  End;
{$F-}

  Procedure AssignLst(Var F : Text);
  Begin
    With TextRec(F) Do
    Begin
      Handle := $FFFF;
      Mode := fmClosed;
      BufSize := SizeOf(Buffer);
      BufPtr := @Buffer;
      OpenProc := @LstOpen;
      Name[0] := #0;
    End;
  End;

  Procedure set_T2000;
    (* T200 ein/aus *)
  Var i : Byte;
  Begin
    If T2000_Flag Then
    Begin
      T2000_Flag := False;
      If Lo(screen^[24, 74]) = Ord('T') Then
        For i := 1 To 5 Do screen^[24, 73+i] := screen^[24, 79];
    End
    Else
    Begin
      T2000_Flag := True;
      If Lo(screen^[24, 74]) = 205 Then
        write_Screen(74, 24, 'T2000', Red, Black);
    End;
    Beep;
  End;

  Function lies_T2000 : Boolean;
  Var x, regbef : str80;
    bufhead : Word Absolute $0040 : $0080;
    buftail : Word Absolute $0040 : $0082;
    keybuff : Array[1..32] Of Byte Absolute $0040 : $001A;
    C:char;
    (*
    Dieses Modul bernimmt die Kommunikation mit dem T2000.
    Es liefert TRUE wenn die Werte korrekt empfangen wurden
    und FALSE falls der Datensatz nicht korrekt ist.
    *)

    Procedure check_block;
      (* Diese Prozedur prft den T2000 Datenblock *)
    Var i : Integer;
      meld : String[40];
    Begin
      lies_T2000 := False;
      If Copy(x, 1, 2) = '41' Then
      Begin
        (* Ein Informationsblock wurde gesendet *)
        Val(Copy(x, 8, 8), T2000_Code, i);
      End
      Else
        If Copy(x, 1, 2) = '31' Then
        Begin
          (* EDM-Gertedaten *)
          meld := '';
          (* Entfernung in Meter ? *)
          If x[6] <> '0' Then meld := 'Falsches Streckenma!';
          (* ppm Korrektur =0 ? *)
          If Copy(x, 25, 3) <> '000' Then meld := 'ppm Korr. > 0!';
          (* Additionskonstante =0 ? *)
          If Copy(x, 29, 3) <> '000' Then meld := 'Add.Konst. <> 0!';
          If meld <> '' Then
          Begin
            Beep; melde(meld); Delay(2000);
          End
          Else
          Begin
            (* Messwerte aus Datenblock bernehmen *)
            T2000.P := '';        (* Punktnummer *)
            T2000.r := 0;         (* Richtung *)
            T2000.z := 100;       (* Zenitdistanz *)
            Val((Copy(x, 8, 5)+'.'+Copy(x, 13, 3)), T2000.d, i); (*Schrgstrecke *)
            lies_T2000 := True;
          End;
        End
      Else
      Begin
        (* Der Block enthlt Mewerte *)
        meld := '';
        (* Richtung und Zenitwinkel in GON ? *)
        If (x[22] <> '2') Or (x[38] <> '2') Then meld := 'Falsches Winkelma!';
        (* Entfernung in Meter ? *)
        If x[54] <> '0' Then meld := 'Falsches Streckenma!';
        (* ppm Korrektur =0 ? *)
        If Copy(x, 72, 4) <> '0000' Then meld := 'ppm Korr. > 0!';
        (* Additionskonstante =0 ? *)
        If Copy(x, 77, 3) <> '000' Then meld := 'Add.Konst. <> 0!';
   (* Kompensator OK ? - Totgelegt wegen T2002 am 28.06.88
	  If (x[20] <> '1') Or (x[36] <> '1') Then meld := 'Kompensator aus!';
	  *)
        If meld <> '' Then
        Begin
          Beep; melde(meld); Delay(2000);
        End
        Else
        Begin
          (* Messwerte aus Datenblock bernehmen *)
          T2000.P := Copy(x, 8, 8); (* Punktnummer *)
          Val((Copy(x, 24, 3)+'.'+Copy(x, 27, 5)), T2000.r, i); (*Richtung *)
          Val((Copy(x, 40, 3)+'.'+Copy(x, 43, 5)), T2000.z, i); (*Zenitdistanz *)
          Val((Copy(x, 56, 5)+'.'+Copy(x, 61, 3)), T2000.d, i); (*Schrgstrecke *)
          lies_T2000 := True;
        End;
      End;
      If T2000.d < 0.5 Then T2000.d := 0;
    End;

  Begin
    (*
    RS232-Schnittstelle mu wie folgt initialisiert sein
    2400 Baud, 7Bits/Zeichen, gerade Paritt, 1 Stoppbit
    InitComPort(comport,2400,3,1,7);
    *)
    (* Messwerte sicherheitshalber auf 0 setzen *)
    T2000_Code := 0; T2000.P := ''; T2000.r := 0; T2000.z := 0; T2000.d := 0;
    (* Achtung ReadLn(Auxinp) liest nur bis CR, LF wird ignoriert und
       beim nchsten Lesevorgang als erstes Zeichen gelesen.
       Zweckmig wird das Satzendezeichen im T2000 auf CR (ohne LF) gesetzt.
    *)
    Repeat
      ReadLn(auxinp, x);
      Delay(100);
      (* LF oder Blank am Satzanfang oder Ende lschen *)
      While (Length(x) > 0) And (x[1] < #32) Do Delete(x, 1, 1);
      If x <> '?' Then WriteLn(auxout, '?');
    Until (x <> '?') and (x<>#10) and (x<>'w');
    If Length(x) > 1 Then check_block;
  End;

  Procedure T2000_ein;
  Var x : str80;
  Begin
    WriteLn(auxout, 'a');
    ReadLn(auxinp, x);
  End;

  Procedure T2000_aus;
  Begin
    WriteLn(auxout, 'b');
  End;


{$I METAMASK}

Begin
  teste_bildschirm;
  AssignLst(lst); Rewrite(lst);
  AssignAux(auxout, 0, 3, 1, 7, 2400); Rewrite(auxout);
  AssignAux(auxinp, 0, 3, 1, 7, 2400); Reset(auxinp);
  SetTermReady(0, True);
  SetClearToSend(0);
End.
