Unit META2;
Interface
Uses Dos, CRT, AuxIO, meta0, meta1,metaSW;

Procedure MaskIO(Par : msk_par_typ);
Procedure get_feld(r, feld : Integer);
Procedure put_feld(r, feld : Integer);
Procedure knopfmittel;
Function feldinp(von, bis : Byte) : msk_rev_typ;
Procedure zeig_felder(von, bis : Byte);

Implementation

  Function rechnen(spalte, zeile : Byte) : Real;
  Const
    komma : Integer = 12;
    dy = 16; DX = 20;
  Var stak : stak_typ;
    i : Integer;
    C : Char;
    eingabe : String[13];
    fertig : Boolean;

    Procedure stack_up(Var stak : stak_typ);
    Begin
      stak.T := stak.z; stak.z := stak.y; stak.y := stak.x;
    End;

    Procedure stack_down(Var stak : stak_typ);
    Begin
      stak.y := stak.z; stak.z := stak.T;
    End;

    Procedure operation(Var stak : stak_typ; operator : Char);
      (* UPN operation processor *)
    Const maxreal = 1E+36;

      Function arcsin(x : Real) : Real;
      Begin
        If Abs(x) = 1 Then arcsin := sgn(x)*Pi/2
        Else arcsin := ArcTan(x/Sqrt(1-x*x));
        x := x*200/Pi;
      End;

      Function arccos
        (x : Real) : Real;
      Begin
        If x = 0 Then arccos := Pi/2
        Else
          If x < 0 Then arccos := Pi+ArcTan(Sqrt(1-x*x)/x)
        Else arccos := ArcTan(Sqrt(1-x*x)/x);
        x := x*200/Pi;
      End;

      Function power(x, y : Real) : Real;
      Begin
        power := 1.0;
        If x = 0.0 Then
          If y = 0.0 Then power := 1.0
          Else power := 0.0
        Else
          If y = 0.0 Then power := 1.0;
        If x > 0.0 Then
          If y > 0.0 Then power := Exp(y*Ln(Abs(x)))
          Else power := Exp(-Abs(y)*Ln(Abs(x)));
      End;

      Function tan(x : Real) : Real;
      Begin
        x := x/200*Pi;
        If Cos(x) = 0 Then tan := 1E29*sgn(Cos(x)) Else tan := Sin(x)/Cos(x);
      End;

      Procedure R_P(Var dy, DX : Real);
      Var S, T : Real;
      Begin
        If DX = 0 Then
          T := sgn(dy)*Pi/2
        Else
          T := ArcTan(dy/DX);
        If DX < 0 Then T := T+Pi;
        If T < 0 Then T := T+Pi+Pi;
        S := Sqrt(dy*dy+DX*DX);
        DX := S; dy := T*200/Pi;
      End;

      Procedure P_R(Var T, S : Real);
      Var x, y : Real;
      Begin
        T := T/200*Pi;
        y := S*Sin(T);
        x := S*Cos(T);
        S := x; T := y;
      End;

    Var h : Real;
    Begin
      With stak Do
        Case operator Of
          #13 : Begin
                  stack_up(stak); stack_down(stak);
                End;
          '^' : stack_up(stak);
          '+' : Begin
                  lastx := x; x := x+y; stack_down(stak);
                End;
          '-' : Begin
                  lastx := x; x := y-x; stack_down(stak);
                End;
          '*' : Begin
                  lastx := x; x := x*y; stack_down(stak);
                End;
          '/' : Begin
                  If x <> 0 Then
                  Begin
                    lastx := x; x := y/x;
                  End
                  Else x := sgn(y)*maxreal;
                  stack_down(stak);
                End;
          '%' : Begin
                  lastx := x; x := y*x/100;
                End;
          'R' : Begin             (*Reziprokwert*)
                  If x <> 0 Then
                  Begin
                    lastx := x; x := 1/x;
                  End
                  Else x := sgn(x)*maxreal;
                End;
          'T' : Begin             (*Tausch x<>y*)
                  h := x; x := y; y := h;
                End;
          '<' : Begin             (*roll down*)
                  h := x; x := y; y := z; z := T; T := h;
                End;
          '>' : Begin             (*roll up*)
                  h := x; x := T; T := z; z := y; y := h;
                End;
          'V' : Begin             (*vorzeichen*)
                  x := -x;
                End;
          'I' : Begin             (*Int*)
                  lastx := x; x := Int(x);
                End;
          'F' : Begin             (*Frac*)
                  lastx := x; x := x-Int(x);
                End;
          'L' : Begin             (*Lastx*)
                  stack_up(stak); x := lastx;
                End;
          'W' : Begin             (*Wurzel*)
                  lastx := x; x := Sqrt(Abs(x));
                End;
          'Q' : Begin             (*Quadrat*)
                  lastx := x; If x <= Sqrt(maxreal) Then x := x*x;
                End;
          'S' : Begin
                  lastx := x; x := Sin(x*Pi/200);
                End;
          'O' : Begin
                  lastx := x; x := Cos(x*Pi/200);
                End;
          'H' : Begin
                  If Abs(x) <= 1 Then
                  Begin
                    lastx := x; x := 200/Pi*arccos(x);
                  End;
                End;
          'G' : Begin
                  If Abs(x) <= 1 Then
                  Begin
                    lastx := x; x := 200/Pi*arcsin(x);
                  End;
                End;
          'A' : Begin
                  lastx := x; x := tan(x);
                End;
          'K' : Begin
                  lastx := x; P_R(y, x);
                End;
          'P' : Begin
                  lastx := x; R_P(y, x);
                End;
        End (*case*) ;
    End;

    Procedure tastenfeld(Var x, y : Byte);
    Begin
      If y > (24-dy) Then y := 1; If y < 1 Then y := 24-dy;
      If x > (80-DX) Then x := 1; If x < 1 Then x := 80-DX;
      save_Window(x, y, x+DX, y+dy);
      write_Screen(x, y+00, 'ͻ', LightGreen, Black);
      write_Screen(x, y+01, ' Ŀ ', LightGreen, Black);
      write_Screen(x, y+02, '                 ', LightGreen, Black);
      write_Screen(x, y+03, '  ', LightGreen, Black);
      write_Screen(x, y+04, ' UPN - CALCULATOR  ', LightGreen, Black);
      write_Screen(x, y+05, ' Ŀ ', LightGreen, Black);
      write_Screen(x, y+06, '  C  %  /  *  ', LightGreen, Black);
      write_Screen(x, y+07, ' Ĵ ', LightGreen, Black);
      write_Screen(x, y+08, '  7  8  9  -  ', LightGreen, Black);
      write_Screen(x, y+09, ' Ĵ ', LightGreen, Black);
      write_Screen(x, y+10, '  4  5  6  +  ', LightGreen, Black);
      write_Screen(x, y+11, ' Ĵ ', LightGreen, Black);
      write_Screen(x, y+12, '  1  2  3  E  ', LightGreen, Black);
      write_Screen(x, y+13, ' Ĵ N  ', LightGreen, Black);
      write_Screen(x, y+14, '    0    .  T  ', LightGreen, Black);
      write_Screen(x, y+15, '  ', LightGreen, Black);
      write_Screen(x, y+16, 'ͼ', LightGreen, Black);
    End;

    Procedure anzeigen;
    Begin
      write_Screen(spalte+4, zeile+2, '             ', LightRed, Black);
      write_Screen(spalte+17-Length(eingabe), zeile+2, eingabe, LightRed, Black);
    End;


  Begin
    With stak Do
    Begin
      x := 0; y := 0; z := 0; T := 0; lastx := 0;
    End;
    tastenfeld(spalte, zeile);
    eingabe := ''; anzeigen;
    Repeat
      C := Readkey; C := Upcase(C);
      Case C Of
        '0'..'9' : Begin
                     If Length(eingabe) < 13 Then eingabe := eingabe+C Else Beep;
                     fertig := False;
                   End;
        '.' : Begin
                i := Pos('.', eingabe);
                If i > 0 Then Delete(eingabe, i, 1);
                If eingabe = '' Then eingabe := '0';
                eingabe := eingabe+C;
                fertig := False;
              End;
        #8 : Begin
               If Ord(eingabe[0]) > 0 Then eingabe[0] := Pred(eingabe[0]);
               fertig := False;
             End;
        'C' : Begin
                eingabe := ''; fertig := False;
              End;
        'D' : Begin
                open_Window(spalte, zeile+4, spalte+DX, zeile+6, LightGreen, Black);
                write_Screen(spalte+1, zeile+5, 'Kommastellen ?', LightGreen, Black);
                GoToXY(spalte+16, zeile+5);
                C := Readkey; komma := Ord(C)-48;
                If (komma < 0) Or (komma > 13) Then komma := 13;
                close_Window(spalte, zeile+4, spalte+DX, zeile+6);
                Str(stak.x:13:komma, eingabe);
                C := Chr(0); fertig := True;
              End;
        #0 : Begin
               C := Readkey;
               Case C Of
                 #68 : Begin
                         open_Window(14, 8, 64, 15, LightGreen, Black);
                         write_Screen(27, 08, ' CALCULATOR FUNKTIONEN ', LightGreen, Black);
                         write_Screen(16, 09, '^Stack UP <Roll down >Roll Up  TX<>Y', LightGreen, Black);
                         write_Screen(16, 10, 'R1/X      VCHS       IINT      FFRAC', LightGreen, Black);
                         write_Screen(16, 11, 'LLAST X   WWurzel    QQuadrat  %Prozent', LightGreen, Black);
                         write_Screen(16, 12, 'SSIN      OCOS       GARCSIN   HARCCOS', LightGreen, Black);
                         write_Screen(16, 13, 'ATAN      KP -> R    PR -> P   =Ende', LightGreen, Black);
                         write_Screen(16, 14, 'DKommast.', LightGreen, Black);
                         Repeat Until KeyPressed;
                         While KeyPressed Do C := Readkey;
                         close_Window(14, 8, 64, 15);
                       End;
                 #75 : Begin
                         close_Window(spalte, zeile, spalte+DX, zeile+dy);
                         spalte := Pred(spalte); tastenfeld(spalte, zeile);
                       End;
                 #77 : Begin
                         close_Window(spalte, zeile, spalte+DX, zeile+dy);
                         spalte := Succ(spalte); tastenfeld(spalte, zeile);
                       End;
                 #72 : Begin
                         close_Window(spalte, zeile, spalte+DX, zeile+dy);
                         zeile := Pred(zeile); tastenfeld(spalte, zeile);
                       End;
                 #80 : Begin
                         close_Window(spalte, zeile, spalte+DX, zeile+dy);
                         zeile := Succ(zeile); tastenfeld(spalte, zeile);
                       End;
               End;
               C := Chr(0); eingabe := ''; fertig := True;
             End;
      Else
        If eingabe <> '' Then
        Begin
          stack_up(stak); stak.x := Val_from_Str(eingabe);
        End;
        fertig := True;
      End;

      anzeigen;

      operation(stak, C);

      If fertig Then
      Begin
        Str(stak.x:13:komma, eingabe);
        anzeigen; eingabe := '';
      End;

    Until C = #61;
    rechnen := stak.x;
    close_Window(spalte, zeile, spalte+DX, zeile+dy);
  End;

  Procedure inhaltsverzeichnis;
  Const atrib = 'N';
  Var dir_e : SearchRec;
    inp : str80;
    drive, i, j : Word;
    zei : Byte;
    C : Char;
    x : Real;
  Begin
    save_Window(1, 1, 80, 25);
    GoToXY(1, 1); ClrScr;
    Write('Inhaltsverzeichnis Matchcode: '); ReadLn(inp);
    WriteLn(ConstStr(79, #205));
    If inp = '' Then inp := '*.*';
    drive := Pos(':', inp);
    If drive > 1 Then drive := Ord(Upcase(inp[Pred(drive)]))-64 Else drive := 0;
    FindFirst(inp, AnyFile, dir_e);
    i := 1;
    While DosError = 0 Do
    Begin
      j := Pred(i) Mod 5;
      j := (j)*15+5;
      zei := Pred(i) Div 5+3;
      scroll(zei, 3, 24, 1, 80, 1);
      write_Screen(j, zei, dir_e.Name, Yellow, Black);
      FindNext(dir_e);
      Inc(i);
    End;
    zei := Succ(zei); scroll(zei, 3, 24, 1, 80, 1);
    x := DiskFree(drive);
    GoToXY(1, zei);
    Write(x:7:0, ' Bytes frei.');
    Repeat Until KeyPressed;
    C := Readkey;
    close_Window(1, 1, 80, 25);
  End;


  Procedure hilfe;
  Const x = 16;
    l = 49;
  Var
    C : Char;
  Begin
    open_Window(x-2, 6, x+l, 17, LightRed, Black);
    write_Screen(x+2, 06, ' META Tastenbelegung ', LightRed, Black);
    write_Screen(x, 07, 'ESC Beenden            INS  Einfgen ein/aus', LightRed, Black);
    write_Screen(x, 08, 'F1  Standpunkt suchen  DEL  Zeichen lschen', LightRed, Black);
    write_Screen(x, 09, 'F2  Knopfmittel        TAB  Zeilenrest lschen', LightRed, Black);
    write_Screen(x, 10, 'F4  Mebandmittel      HOME zum Feldanfang', LightRed, Black);
    write_Screen(x, 11, 'F5  Basislattenmittel  END  zum Feldende', LightRed, Black);
    write_Screen(x, 12, 'F6  EDM-Mittel         >  Zeichen rechts', LightRed, Black);
    write_Screen(x, 13, 'F7  T2000 Ein/Aus      <  Zeichen links', LightRed, Black);
    write_Screen(x, 14, 'F8  Rechner            Auf  Feld zurck', LightRed, Black);
    write_Screen(x, 15, 'F9  Inhaltsverzeichnis Ab   Feld vor', LightRed, Black);
    write_Screen(x, 16, 'F10 Hilfe', LightRed, Black);
    Repeat Until KeyPressed;
    C := Readkey;
    close_Window(x-2, 6, x+l, 17);
  End;
 {
  Procedure Tageszeit;
    (* Tag und Zeit anzeigen *)
  Var
    Tag : str8;
    Name : str2;
    inp : str40;
    C : Char;
    rec : Integer;
    betrdat : File Of Real;
    Zeit : Real;
  Begin
    open_Window(22, 10, 58, 13, LightRed, Black);
    get_datum(Tag, Name, Zeit);
    write_Screen(23, 11, 'Heute ist '+Name+', der '+Tag, LightRed, Black);
    Str(Zeit:6:2, inp); inp := 'Es ist'+inp+' Uhr.';
    write_Screen(23, 12, inp, LightRed, Black);
    Repeat Until KeyPressed;
    While KeyPressed Do c:=Readkey;
    close_Window(22, 10, 58, 13);
  End;
}
  Function check_date(Datum : str6) : Boolean;
  Var day, month, year, flg : Integer;
  Begin
    If Datum = '' Then check_date := True
    Else
    Begin
      Datum := Copy('000000'+Datum, Succ(Length(Datum)), 6);
      Val(Copy(Datum, 1, 2), day, flg);
      Val(Copy(Datum, 3, 2), month, flg);
      Val(Copy(Datum, 5, 2), year, flg);
      Case month Of
        1, 3, 5, 7, 8, 10, 12 : check_date := day In [1..31];
        4, 6, 9, 11 : check_date := day In [1..30];
        2 : If year Mod 4 = 0 Then check_date := day In [1..29]
            Else check_date := day In [1..28];
      Else check_date := False
      End;
    End;
  End;

  Procedure MaskIO(Par : msk_par_typ);
    (*
    Eingabe : par IO-Feldbeschreibung
    msk_inp Eingabetext  oder
    msk_val Eingabewert
    Ausgabe : msk_inp Eingabetext  und
    msk_val Eingabewert
    msk_rev Abbruchinformation
    *)

  Const fill = '_';               (* Feldfller *)
  Var
    P, i : Integer;
    Ch : Char;

    Procedure SetCursorMode;
    Begin
      If ins_Flag Then cursor(3) Else cursor(2);
    End;

    Function fertig : Boolean;
    Begin
      fertig := True; cursor(0);
      While (Length(msk_inp) > 0) And (msk_inp[Length(msk_inp)] = #32) Do
        Delete(msk_inp, Length(msk_inp), 1);
      P := Length(msk_inp);
      If Par.opt In ['P', 'N', 'T'] Then
      Begin
        If (Par.opt = 'T') And Not check_date(msk_inp) Then
        Begin
          Beep; fertig := False; SetCursorMode; P := 0;
        End
        Else
        Begin
          msk_val := Val_from_Str(msk_inp);
          Str(msk_val:Par.l:Par.komma, msk_inp);
          write_Screen(Par.x, set_ri(Par.y), msk_inp, Yellow, Black);
        End;
      End
      Else
        write_Screen(Par.x, set_ri(Par.y), msk_inp+ConstStr(Par.l-P, fill), Yellow, Black);
    End;

  Begin
    (* Test auf numerischen Eingabewert *)
    If Par.opt In ['P', 'N', 'T'] Then Str(msk_val:Par.l:Par.komma, msk_inp);
    (* Eingabfeld trimmen *)
    msk_inp := Copy(msk_inp, 1, Par.l);
    (* Blanks am Anfang abschneiden *)
    While Not(Par.opt In ['A', 'u']) And (msk_inp[1] <= #32) And (Length(msk_inp) > 0) Do
      Delete(msk_inp, 1, 1);
    (* Bei Datumformat mit 000.. auffllen *)
    If Par.opt = 'T' Then
    Begin
      msk_inp := Copy('000000'+msk_inp, Length(msk_inp)+1, 6);
      If msk_val = 0 Then msk_inp := '';
    End;
    (* Keine Eingabe nur Anzeigen *)
    If Par.io = 'O' Then
      If fertig Then Exit;
    If msk_inp < #32 Then msk_inp := '';
    If (Par.opt In ['P', 'N']) And (msk_val = 0) Then msk_inp := '0';
    write_Screen(Par.x, set_ri(Par.y), msk_inp+
                 ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
    SetCursorMode;
    P := 0;
    Repeat
      If P >= Par.l Then P := Pred(Par.l);
      GoToXY(Par.x+P, set_ri(Par.y));
      Ch := Readkey;
      If Ch = #0 Then
      Begin
        Ch := Readkey;
        Case Ord(Ch) Of
          (* Home *)
          71 : P := 0;
          (* End *)
          79 : P := Length(msk_inp);
          (* Cs up *)
          72 : Begin
                 msk_rev := Up; If fertig Then Exit;
               End;
          (* Cs Do *)
          80 : Begin
                 msk_rev := Down; If fertig Then Exit;
               End;
          (* Cs li *)
          75 : If P > 0 Then P := Pred(P) Else Beep;
          (* Cs re *)
          77 : If Succ(P) < Length(msk_inp) Then P := Succ(P) Else Beep;
          (* F1 *)
          59 : Begin
                 msk_rev := F1; If fertig Then Exit;
               End;
          (* F2 *)
          60 : Begin
                 msk_rev := F2; If fertig Then Exit;
               End;
          (* F3 *)
          61 : Begin
                 msk_rev := F3; If fertig Then Exit;
               End;
          (* F4 *)
          62 : Begin
                 msk_rev := F4; If fertig Then Exit;
               End;
          (* F5 *)
          63 : Begin
                 msk_rev := F5; If fertig Then Exit;
               End;
          (* F6 *)
          64 : Begin
                 msk_rev := F6; If fertig Then Exit;
               End;
          (* F7 *)
          65 : Begin
                 set_T2000;
               End;
          (* F8 *)
          66 : Begin
                 cursor(0);
                 msk_val := rechnen(59, 1);
                 If Par.opt In ['P', 'N', 'T', 'n', 'p'] Then
                 Begin
                   Str(msk_val:Par.l:Par.komma, msk_inp);
                   msk_inp := Copy(msk_inp, 1, Par.l);
                   (* blanks am Anfang abschneiden *)
                   While (msk_inp[1] <= #32) And (Length(msk_inp) > 0) Do
                     Delete(msk_inp, 1, 1);
                   write_Screen(Par.x, set_ri(Par.y), msk_inp+
                                ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
                   P := 0;
                 End;
                 SetCursorMode;
               End;
          (* F9 *)
          67 : Begin
                 inhaltsverzeichnis;
               End;
          (* F10 Hilfe *)
          68 : Begin
                 hilfe;
               End;
          (* PgUp *)
          73 : Begin
                 msk_rev := PgUp; If fertig Then Exit;
               End;
          (* PgDown *)
          81 : Begin
                 msk_rev := PgDown; If fertig Then Exit;
               End;
          (* Ins *)
          82 : Begin
                 If ins_Flag Then ins_Flag := False Else ins_Flag := True;
                 SetCursorMode;
               End;
          (* Del *)
          83 : If P < Length(msk_inp) Then
               Begin
                 Delete(msk_inp, Succ(P), 1);
                 write_Screen(Par.x, set_ri(Par.y), msk_inp+
                              ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
               End;
        End;
      End
      Else
        Case Ord(Ch) Of
          (* BackSpace *)
          8 : If P > 0 Then
              Begin
                Delete(msk_inp, P, 1);
                P := Pred(P);
                write_Screen(Par.x, set_ri(Par.y), msk_inp+
                             ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
              End
              Else Beep;
          (* CLR *)
          9 : Begin
                Delete(msk_inp, Succ(P), Par.l);
                write_Screen(Par.x, set_ri(Par.y), msk_inp+
                             ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
              End;
          (* RET *)
          13 : Begin
                 msk_rev := RET; If fertig Then Exit;
               End;
          (* Abbruch mit ESC *)
          27 : Begin
                 msk_rev := ESC; If fertig Then Exit;
               End;
        Else
          Begin
            (* Nur Grobuchstaben *)
            If Par.opt In ['U', 'u'] Then Ch := Upcase(Ch);

            (* Zeichen einfgen *)
            If P < Par.l Then
            Begin
              Case Par.opt Of
                'A', 'U', 'u' :
                  If (Ch In [#32..#225]) Then
                  Begin
                    If P < Par.l Then
                    Begin
                      If Par.opt In ['A', 'U', 'u'] Then
                      Begin
                        If ins_Flag Then
                        Begin
                          Insert(Ch, msk_inp, P+1);
                          msk_inp := Copy(msk_inp, 1, Par.l);
                          P := Succ(P);
                        End
                        Else
                        Begin
                          P := Succ(P);
                          If P <= Length(msk_inp) Then Delete(msk_inp, P, 1);
                          Insert(Ch, msk_inp, P);
                        End;
                        write_Screen(Par.x, set_ri(Par.y), msk_inp+
                                     ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
                      End;
                    End;
                  End;
                'N', 'P' :
                  If (Ch In ['-', '.', #48..#57]) Then
                  Begin
                    If (Ch = '-') And (Par.opt = 'N') Then
                    Begin
                      If msk_inp[1] <> '-' Then
                      Begin
                        Insert('-', msk_inp, 1);
                        P := Succ(P);
                      End
                      Else
                      Begin
                        Delete(msk_inp, 1, 1);
                        If P > 0 Then P := Pred(P);
                      End;
                      write_Screen(Par.x, set_ri(Par.y), msk_inp+
                                   ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
                    End;
                    If (Ch = '.') And (Pos(Ch, msk_inp) > 0) And
                    (Length(msk_inp) > 0) Then
                      Delete(msk_inp, Pos(Ch, msk_inp), 1);
                    If (Ch In ['.', #48..#57]) Then
                    Begin
                      If ins_Flag Then
                      Begin
                        Insert(Ch, msk_inp, P+1);
                        msk_inp := Copy(msk_inp, 1, Par.l);
                        P := Succ(P);
                      End
                      Else
                      Begin
                        P := Succ(P);
                        If P <= Length(msk_inp) Then Delete(msk_inp, P, 1);
                        Insert(Ch, msk_inp, P);
                      End;
                      write_Screen(Par.x, set_ri(Par.y), msk_inp+
                                   ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
                    End;
                  End;
                'T' :
                  If Ch In [#48..#57] Then
                  Begin
                    If ins_Flag Then
                    Begin
                      Insert(Ch, msk_inp, P+1);
                      msk_inp := Copy(msk_inp, 1, Par.l);
                      P := Succ(P);
                    End
                    Else
                    Begin
                      P := Succ(P);
                      If P <= Length(msk_inp) Then Delete(msk_inp, P, 1);
                      Insert(Ch, msk_inp, P);
                    End;
                    write_Screen(Par.x, set_ri(Par.y), msk_inp+
                                 ConstStr(Par.l-Length(msk_inp), fill), Yellow, Black);
                  End;
              End (* case *) ;
            End Else Beep;        (* p>par.l *)
          End (* ch<>'' *) ;
        End;                      (* Else case *)
    Until False;
  End;

  Procedure get_feld(r, feld : Integer);
    (* Zuweisung Dateipuffer ---> IO-Feld *)
  Begin
    Case Satz_Art Of
      Auftrag :
        Case feld Of
          01 : msk_inp := Buffer.Au.Aktenz;
          02 : msk_inp := Buffer.Au.Arb_Plan;
          03 : msk_inp := Buffer.Au.Gemarkung;
          04 : msk_inp := Buffer.Au.Beobachter;
          05 : msk_val := Buffer.Au.LVBernr;
          06 : msk_val := Buffer.Au.MetaBernr;
          07..16 : msk_val := Buffer.Au.TK25[feld-6];
        End;
      Geraet :
        Case feld Of
          01 : msk_val := Buffer.Ge.Index;
          02 : msk_inp := Buffer.Ge.Nummer;
          03 : msk_inp := Buffer.Ge.Name;
          04 : msk_inp := Buffer.Ge.Kennung;
          05 : msk_val := Buffer.Ge.A;
          06 : msk_val := Buffer.Ge.B;
          07 : msk_val := Buffer.Ge.C;
          08 : msk_val := Buffer.Ge.d;
          09 : msk_inp := Buffer.Ge.Sig[1].bp;
          10 : msk_val := Buffer.Ge.Sig[1].r0;
          11 : msk_val := Buffer.Ge.Sig[1].h0;
          12 : msk_val := Buffer.Ge.Sig[1].Hub;
          13 : msk_val := Buffer.Ge.Sig[1].Al;
          14 : msk_inp := Buffer.Ge.Sig[2].bp;
          15 : msk_val := Buffer.Ge.Sig[2].r0;
          16 : msk_val := Buffer.Ge.Sig[2].h0;
          17 : msk_val := Buffer.Ge.Sig[2].Hub;
          18 : msk_val := Buffer.Ge.Sig[2].Al;
          19 : msk_inp := Buffer.Ge.Sig[3].bp;
          20 : msk_val := Buffer.Ge.Sig[3].r0;
          21 : msk_val := Buffer.Ge.Sig[3].h0;
          22 : msk_val := Buffer.Ge.Sig[3].Hub;
          23 : msk_val := Buffer.Ge.Sig[3].Al;
        End;
      Station, Ziel :
        Case feld Of
          01 : msk_inp := Standpunkt.Ps;
          02 : msk_inp := Standpunkt.Pfeiler;
          03 : msk_val := Standpunkt.p_ps;
          04 : msk_inp := Standpunkt.Bem;
          05 : msk_inp := Zielpunkt[r].Pz;
          06 : msk_val := Zielpunkt[r].tt;
          07 : msk_val := Zielpunkt[r].tf;
          08 : msk_val := Zielpunkt[r].p_Pz;
          09 : msk_inp := Zielpunkt[r].Bem;
          10 : msk_val := Zielpunkt[r].F;
          11 : msk_val := Zielpunkt[r].T;
          12 : msk_val := Zielpunkt[r].E;
          13 : msk_val := Zielpunkt[r].r;
          14 : msk_val := Zielpunkt[r].rm;
          15 : msk_val := Zielpunkt[r].Ri[0, 1];
          16 : msk_val := Zielpunkt[r].Ri[0, 2];
          17 : msk_val := Zielpunkt[r].Ri[0, 3];
          18 : msk_val := Zielpunkt[r].Ri[1, 1];
          19 : msk_val := Zielpunkt[r].Ri[1, 2];
          20 : msk_val := Zielpunkt[r].Ri[1, 3];
          21 : msk_val := Zielpunkt[r].Ri[2, 1];
          22 : msk_val := Zielpunkt[r].Ri[2, 2];
          23 : msk_val := Zielpunkt[r].Ri[2, 3];
          24 : msk_val := Zielpunkt[r].Ri[3, 1];
          25 : msk_val := Zielpunkt[r].Ri[3, 2];
          26 : msk_val := Zielpunkt[r].Ri[3, 3];
          27 : msk_val := Zielpunkt[r].zd;
          28 : msk_val := Zielpunkt[r].z1;
          29 : msk_val := Zielpunkt[r].z2;
          30 : msk_val := Zielpunkt[r].z3;
          31 : msk_val := Zielpunkt[r].z4;
          32 : msk_val := Zielpunkt[r].zi*1E4;
          33 : msk_val := Zielpunkt[r].zv*1E4;
          34 : msk_val := Zielpunkt[r].S;
          35 : msk_val := Zielpunkt[r].seitw;
          36 : msk_val := Zielpunkt[r].exz;
          37 : msk_val := Zielpunkt[r].d;
          38 : msk_val := Zielpunkt[r].MG;
          39 : msk_val := Zielpunkt[r].dH;
        End;
      Azimut1, Azimut2, Azimut3 :
        Case feld Of
          01 : msk_inp := Azi1.Ps;
          02 : msk_val := Azi1.YS;
          03 : msk_val := Azi1.XS;
          04 : msk_val := Azi1.HS;
          05 : msk_inp := Azi1.Pz;
          06 : msk_val := Azi1.YZ;
          07 : msk_val := Azi1.XZ;
          08 : msk_val := Azi1.HZ;
          09 : msk_val := Azi1.LS;
          10 : msk_val := Azi1.BS;
          11 : msk_val := Azi1.cS;
          12 : msk_val := Azi1.LZ;
          13 : msk_val := Azi1.BZ;
          14 : msk_val := Azi1.cZ;
          16 : msk_val := Azi3[1].MEZSoll;
          15 : msk_val := Azi3[1].UhrIst;
          17 : msk_val := Azi3[1].DeltaU;
          19 : msk_val := Azi3[2].MEZSoll;
          18 : msk_val := Azi3[2].UhrIst;
          20 : msk_val := Azi3[2].DeltaU;
          21 : msk_val := Azi1.Datum;
          22 : msk_inp := Azi1.Bem;
          23 : msk_val := Azi3[1].RZ;
          24 : msk_inp := Azi3[1].RH[1].Rand;
          26 : msk_val := Azi3[1].RH[1].Ri;
          25 : msk_val := Azi3[1].RH[1].Uhr;
          27 : msk_inp := Azi3[1].RH[2].Rand;
          29 : msk_val := Azi3[1].RH[2].Ri;
          28 : msk_val := Azi3[1].RH[2].Uhr;
          30 : msk_inp := Azi3[1].RH[3].Rand;
          32 : msk_val := Azi3[1].RH[3].Ri;
          31 : msk_val := Azi3[1].RH[3].Uhr;
          33 : msk_inp := Azi3[1].RH[4].Rand;
          35 : msk_val := Azi3[1].RH[4].Ri;
          34 : msk_val := Azi3[1].RH[4].Uhr;
          36 : msk_inp := Azi3[1].RH[5].Rand;
          38 : msk_val := Azi3[1].RH[5].Ri;
          37 : msk_val := Azi3[1].RH[5].Uhr;
          39 : msk_val := Azi3[2].RZ;
          40 : msk_inp := Azi3[2].RH[1].Rand;
          42 : msk_val := Azi3[2].RH[1].Ri;
          41 : msk_val := Azi3[2].RH[1].Uhr;
          43 : msk_inp := Azi3[2].RH[2].Rand;
          45 : msk_val := Azi3[2].RH[2].Ri;
          44 : msk_val := Azi3[2].RH[2].Uhr;
          46 : msk_inp := Azi3[2].RH[3].Rand;
          48 : msk_val := Azi3[2].RH[3].Ri;
          47 : msk_val := Azi3[2].RH[3].Uhr;
          49 : msk_inp := Azi3[2].RH[4].Rand;
          51 : msk_val := Azi3[2].RH[4].Ri;
          50 : msk_val := Azi3[2].RH[4].Uhr;
          52 : msk_inp := Azi3[2].RH[5].Rand;
          54 : msk_val := Azi3[2].RH[5].Ri;
          53 : msk_val := Azi3[2].RH[5].Uhr;
          55 : msk_val := Azi1.tm;
          56 : msk_val := Azi2.S;
          57 : msk_val := Azi2.d;
          58 : msk_val := Azi2.dH;
          59 : msk_val := Azi2.F;
          60 : msk_val := Azi2.T;
          61 : msk_val := Azi2.E;
          62 : msk_val := Azi2.r;
          63 : msk_val := Azi2.z;
          64 : msk_val := Azi2.z1;
          65 : msk_val := Azi2.z2;
          66 : msk_val := Azi2.z3;
          67 : msk_val := Azi2.z4;
          68 : msk_val := Azi2.Druck;
          69 : msk_val := Azi2.Temp;
          70 : msk_val := Azi2.MG;
        End;
    End;
  End;

  Procedure put_feld(r, feld : Integer);
    (* Zuweisung der IO-Feldwerte --> Dateipuffer *)
  Begin
    Case Satz_Art Of
      Auftrag :
        Case feld Of
          01 : Buffer.Au.Aktenz := msk_inp;
          02 : Buffer.Au.Arb_Plan := msk_inp;
          03 : Buffer.Au.Gemarkung := msk_inp;
          04 : Buffer.Au.Beobachter := msk_inp;
          05 : Buffer.Au.LVBernr := Trunc(msk_val);
          06 : Buffer.Au.MetaBernr := Trunc(msk_val);
          07..16 : Buffer.Au.TK25[feld-6] := Trunc(msk_val);
        End;
      Geraet :
        Case feld Of
          01 : Buffer.Ge.Index := Trunc(msk_val);
          02 : Buffer.Ge.Nummer := msk_inp;
          03 : Buffer.Ge.Name := msk_inp;
          04 : Buffer.Ge.Kennung := msk_inp;
          05 : Buffer.Ge.A := msk_val;
          06 : Buffer.Ge.B := msk_val;
          07 : Buffer.Ge.C := msk_val;
          08 : Buffer.Ge.d := msk_val;
          09 : Buffer.Ge.Sig[1].bp := msk_inp;
          10 : Buffer.Ge.Sig[1].r0 := msk_val;
          11 : Buffer.Ge.Sig[1].h0 := msk_val;
          12 : Buffer.Ge.Sig[1].Hub := msk_val;
          13 : Buffer.Ge.Sig[1].Al := msk_val;
          14 : Buffer.Ge.Sig[2].bp := msk_inp;
          15 : Buffer.Ge.Sig[2].r0 := msk_val;
          16 : Buffer.Ge.Sig[2].h0 := msk_val;
          17 : Buffer.Ge.Sig[2].Hub := msk_val;
          18 : Buffer.Ge.Sig[2].Al := msk_val;
          19 : Buffer.Ge.Sig[3].bp := msk_inp;
          20 : Buffer.Ge.Sig[3].r0 := msk_val;
          21 : Buffer.Ge.Sig[3].h0 := msk_val;
          22 : Buffer.Ge.Sig[3].Hub := msk_val;
          23 : Buffer.Ge.Sig[3].Al := msk_val;
        End;
      Station, Ziel :
        Case feld Of
          01 : Standpunkt.Ps := msk_inp;
          02 : Standpunkt.Pfeiler := msk_inp;
          03 : Standpunkt.p_ps := msk_val;
          04 : Standpunkt.Bem := msk_inp;
          05 : Zielpunkt[r].Pz := msk_inp;
          06 : Zielpunkt[r].tt := msk_val;
          07 : Zielpunkt[r].tf := msk_val;
          08 : Zielpunkt[r].p_Pz := msk_val;
          09 : Zielpunkt[r].Bem := msk_inp;
          10 : Zielpunkt[r].F := msk_val;
          11 : Zielpunkt[r].T := msk_val;
          12 : Zielpunkt[r].E := msk_val;
          13 : Zielpunkt[r].r := msk_val;
          14 : Zielpunkt[r].rm := msk_val;
          15 : Zielpunkt[r].Ri[0, 1] := msk_val;
          16 : Zielpunkt[r].Ri[0, 2] := msk_val;
          17 : Zielpunkt[r].Ri[0, 3] := msk_val;
          18 : Zielpunkt[r].Ri[1, 1] := msk_val;
          19 : Zielpunkt[r].Ri[1, 2] := msk_val;
          20 : Zielpunkt[r].Ri[1, 3] := msk_val;
          21 : Zielpunkt[r].Ri[2, 1] := msk_val;
          22 : Zielpunkt[r].Ri[2, 2] := msk_val;
          23 : Zielpunkt[r].Ri[2, 3] := msk_val;
          24 : Zielpunkt[r].Ri[3, 1] := msk_val;
          25 : Zielpunkt[r].Ri[3, 2] := msk_val;
          26 : Zielpunkt[r].Ri[3, 3] := msk_val;
          27 : Zielpunkt[r].zd := msk_val;
          28 : Zielpunkt[r].z1 := msk_val;
          29 : Zielpunkt[r].z2 := msk_val;
          30 : Zielpunkt[r].z3 := msk_val;
          31 : Zielpunkt[r].z4 := msk_val;
          32 : Zielpunkt[r].zi := msk_val;
          33 : Zielpunkt[r].zv := msk_val;
          34 : Zielpunkt[r].S := msk_val;
          35 : Zielpunkt[r].seitw := msk_val;
          36 : Zielpunkt[r].exz := msk_val;
          37 : Zielpunkt[r].d := msk_val;
          38 : Zielpunkt[r].MG := Trunc(msk_val);
          39 : Zielpunkt[r].dH := msk_val;
        End;
      Azimut1, Azimut2, Azimut3 :
        Case feld Of
          01 : Azi1.Ps := msk_inp;
          02 : Azi1.YS := msk_val;
          03 : Azi1.XS := msk_val;
          04 : Azi1.HS := msk_val;
          05 : Azi1.Pz := msk_inp;
          06 : Azi1.YZ := msk_val;
          07 : Azi1.XZ := msk_val;
          08 : Azi1.HZ := msk_val;
          09 : Azi1.LS := msk_val;
          10 : Azi1.BS := msk_val;
          11 : Azi1.cS := msk_val;
          12 : Azi1.LZ := msk_val;
          13 : Azi1.BZ := msk_val;
          14 : Azi1.cZ := msk_val;
          16 : Azi3[1].MEZSoll := msk_val;
          15 : Azi3[1].UhrIst := msk_val;
          17 : Azi3[1].DeltaU := msk_val;
          19 : Azi3[2].MEZSoll := msk_val;
          18 : Azi3[2].UhrIst := msk_val;
          20 : Azi3[2].DeltaU := msk_val;
          21 : Azi1.Datum := msk_val;
          22 : Azi1.Bem := msk_inp;
          23 : Azi3[1].RZ := msk_val;
          24 : Azi3[1].RH[1].Rand := msk_inp[1];
          26 : Azi3[1].RH[1].Ri := msk_val;
          25 : Azi3[1].RH[1].Uhr := msk_val;
          27 : Azi3[1].RH[2].Rand := msk_inp[1];
          29 : Azi3[1].RH[2].Ri := msk_val;
          28 : Azi3[1].RH[2].Uhr := msk_val;
          30 : Azi3[1].RH[3].Rand := msk_inp[1];
          32 : Azi3[1].RH[3].Ri := msk_val;
          31 : Azi3[1].RH[3].Uhr := msk_val;
          33 : Azi3[1].RH[4].Rand := msk_inp[1];
          35 : Azi3[1].RH[4].Ri := msk_val;
          34 : Azi3[1].RH[4].Uhr := msk_val;
          36 : Azi3[1].RH[5].Rand := msk_inp[1];
          38 : Azi3[1].RH[5].Ri := msk_val;
          37 : Azi3[1].RH[5].Uhr := msk_val;
          39 : Azi3[2].RZ := msk_val;
          40 : Azi3[2].RH[1].Rand := msk_inp[1];
          42 : Azi3[2].RH[1].Ri := msk_val;
          41 : Azi3[2].RH[1].Uhr := msk_val;
          43 : Azi3[2].RH[2].Rand := msk_inp[1];
          45 : Azi3[2].RH[2].Ri := msk_val;
          44 : Azi3[2].RH[2].Uhr := msk_val;
          46 : Azi3[2].RH[3].Rand := msk_inp[1];
          48 : Azi3[2].RH[3].Ri := msk_val;
          47 : Azi3[2].RH[3].Uhr := msk_val;
          49 : Azi3[2].RH[4].Rand := msk_inp[1];
          51 : Azi3[2].RH[4].Ri := msk_val;
          50 : Azi3[2].RH[4].Uhr := msk_val;
          52 : Azi3[2].RH[5].Rand := msk_inp[1];
          54 : Azi3[2].RH[5].Ri := msk_val;
          53 : Azi3[2].RH[5].Uhr := msk_val;
          55 : Azi1.tm := msk_val;
          56 : Azi2.S := msk_val;
          57 : Azi2.d := msk_val;
          58 : Azi2.dH := msk_val;
          59 : Azi2.F := msk_val;
          60 : Azi2.T := msk_val;
          61 : Azi2.E := msk_val;
          62 : Azi2.r := msk_val;
          63 : Azi2.z := msk_val;
          64 : Azi2.z1 := msk_val;
          65 : Azi2.z2 := msk_val;
          66 : Azi2.z3 := msk_val;
          67 : Azi2.z4 := msk_val;
          68 : Azi2.Druck := msk_val;
          69 : Azi2.Temp := msk_val;
          70 : Azi2.MG := Trunc(msk_val);
          71 : Azi1.Bem := msk_inp;
        End;
    End;
  End;

  Function bala : Real;
    (* Basislattenmessung *)
  Label 00, 99;
  Var i, n, zei : Byte;
    merkrichtung, merkerstrichtung : Integer;
    gamma : Array[0..7] Of Real;
    vv, S : Real;
    prm : msk_par_typ;
    Ch : Char;
  Begin
    open_Window(1, 1, 65, 10, Green, Black);
    merkrichtung := Richtung; merkerstrichtung := ErstRichtung;
    Richtung := 0; ErstRichtung := 0;
    write_Screen(3, 1, 'Links       Rechts    Gamma     Mittel     S         mS', Green, Black);
    write_Screen(3, 10, 'Basislattenmessung', Green, Black);
    n := 0; zei := 1;
    Repeat
      zei := zei+1;
00:   With prm Do
      Begin
        io := 'I'; opt := 'P'; x := 3; y := zei; l := 8; komma := 4;
      End;
      msk_val := 0;
      MaskIO(prm);
      If msk_rev = ESC Then GoTo 99;
      S := msk_val;
      prm.x := 13; msk_val := 0; MaskIO(prm);
      Case msk_rev Of
        Up, ESC : GoTo 00;
      End;
      n := n+1; gamma[n] := msk_val-S;
      write_screen_real(23, zei, 10, 4, gamma[n], Yellow, Black);
99:
    Until (msk_rev = ESC) Or (n = 7);
    gamma[0] := 0; vv := 0;
    For i := 1 To n Do gamma[0] := gamma[0]+gamma[i];
    If n > 1 Then
    Begin
      gamma[0] := gamma[0]/n;
      For i := 1 To n Do vv := vv+Sqr(gamma[i]-gamma[0]);
      vv := Sqrt(vv/(n-1))/Sqrt(n);
    End
    Else vv := 0;
    S := gamma[0]/2*Pi/200;
    If S > 0 Then S := Cos(S)/Sin(S);
    vv := vv*7.85E-3*Sqr(S);
    write_screen_real(33, 2, 8, 4, gamma[0], Yellow, Black);
    write_screen_real(41, 2, 8, 3, S, Yellow, Black);
    write_Screen(50, 2, '', Yellow, Black);
    write_screen_real(51, 2, 8, 4, vv, Yellow, Black);
    bala := S;
    Repeat Until KeyPressed;
    While KeyPressed Do Ch := Readkey;
    Richtung := merkrichtung;
    ErstRichtung := merkerstrichtung;
    close_Window(1, 1, 65, 10);
  End;

  Function messband : Real;
    (* Messbandmessung *)
  Label 00, 99;
  Var i, n, zei : Byte;
    merkrichtung, merkerstrichtung : Integer;
    x : Array[0..7] Of Real;
    S : Real;
    prm : msk_par_typ;
    Ch : Char;
  Begin
    open_Window(1, 1, 43, 10, Green, Black);
    merkrichtung := Richtung; merkerstrichtung := ErstRichtung;
    Richtung := 0; ErstRichtung := 0;

    write_Screen(3, 1, 'Ablesung  Ablesung Strecke   Mittel', Green, Black);
    write_Screen(3, 10, 'Mebandmessung', Green, Black);
    TextColor(Yellow);
    TextBackground(Black);
    n := 0; zei := 1;
    Repeat
      zei := zei+1;
00:   prm.io := 'I'; prm.opt := 'P'; prm.x := 3; prm.y := zei; prm.l := 7; prm.
      komma := 3;
      msk_val := 0;
      MaskIO(prm);
      If msk_rev = ESC Then GoTo 99;
      S := msk_val;
      prm.x := 13; msk_val := 0; MaskIO(prm);
      Case msk_rev Of
        Up, ESC : GoTo 00;
      End;
      n := n+1; x[n] := Abs(msk_val-S);
      write_screen_real(23, zei, 7, 3, x[n], Yellow, Black);
99:
    Until (msk_rev = ESC) Or (n = 7);
    x[0] := 0;
    For i := 1 To n Do x[0] := x[0]+x[i];
    If n > 1 Then x[0] := x[0]/n;
    write_screen_real(33, 2, 7, 3, x[0], Yellow, Black);
    messband := x[0];
    Repeat Until KeyPressed;
    While KeyPressed Do Ch := Readkey;
    Richtung := merkrichtung;
    ErstRichtung := merkerstrichtung;
    close_Window(1, 1, 43, 10);
  End;

  Function edm : Real;
    (* EDM-Schrgstreckenmessung *)
  Label 01;
  Var i, n, zei : Byte;
    merkrichtung, merkerstrichtung : Integer;
    x : Array[0..7] Of Real;
    vv : Real;
    prm : msk_par_typ;
    Ch : Char;
  Begin
    open_Window(1, 1, 38, 10, Green, Black);
    merkrichtung := Richtung; merkerstrichtung := ErstRichtung;
    Richtung := 0; ErstRichtung := 0;
    write_Screen(4, 1, 'Ablesung    Mittel     mS', Green, Black);
    write_Screen(3, 10, 'Streckenmessung', Green, Black);
    TextColor(Yellow);
    TextBackground(Black);
    For n := 0 To 7 Do x[n] := 0;
    zei := 1;
    Repeat
      zei := zei+1;
      If zei > 8 Then zei := 2;
01:   prm.io := 'I'; prm.opt := 'P'; prm.x := 3; prm.y := zei; prm.l := 10; prm.
      komma := 3;
      msk_val := x[Pred(zei)];
      MaskIO(prm);
      Case msk_rev Of
        Up : If zei > 2 Then
             Begin
               Dec(zei); GoTo 01;
             End
             Else Beep;
        RET : Begin
                x[Pred(zei)] := msk_val;
              End;
      End;
    Until msk_rev = ESC;
    x[0] := 0; vv := 0; n := 0;
    For i := 1 To 7 Do
      If x[i] > 0 Then
      Begin
        Inc(n); x[0] := x[0]+x[i];
      End;
    If n > 1 Then
    Begin
      x[0] := x[0]/n;
      For i := 1 To n Do vv := vv+Sqr(x[i]-x[0]);
      vv := Sqrt(vv/(n-1))/Sqrt(n);
    End
    Else vv := 0;
    write_screen_real(15, 2, 7, 3, x[0], Yellow, Black);
    write_Screen(23, 2, '', Yellow, Black);
    write_screen_real(25, 2, 7, 3, vv, Yellow, Black);
    If vv > 0.01 Then
    Begin
      If Not JaNein('Mitteln trotz Fehler') Then GoTo 01;
    End
    Else
    Begin
      Repeat Until KeyPressed;
      While KeyPressed Do Ch := Readkey;
    End;
    edm := x[0];
    Richtung := merkrichtung;
    ErstRichtung := merkerstrichtung;
    close_Window(1, 1, 38, 10);
  End;

  Procedure signalhoehe;
  Var i, j : Byte;
    prm : msk_par_typ;
  Begin
    i := 0;
    Repeat
      i := Succ(i);
      If bt[i].bp = Zielpunkt[Richtung].Pz Then
      Begin
        If bt[i].Al = 1 Then msk_val := bt[i].h0
        Else
        Begin
          j := set_ri(11);
          open_Window(25, j, 55, j+2, Green, Black);
          write_Screen(27, Succ(j), 'Reflektorrichtswinkel', Green, Black);
          prm.io := 'I'; prm.y := 12; prm.x := 49; prm.l := 5;
          prm.komma := 1; prm.opt := 'P';
          MaskIO(prm);
          msk_val := msk_val-bt[i].r0;
          While msk_val < 0 Do msk_val := msk_val+400;
          msk_val := bt[i].h0+msk_val/bt[i].Al*bt[i].Hub;
          close_Window(25, j, 55, j+2);
        End;
      End;
    Until (msk_val > 0) Or (i = max_Signal);
  End;

  Procedure knopfmittel;
  Var i, j : Byte;
    prm : msk_par_typ;
    w1, w2 : Real;
  Begin
    j := set_ri(13);
    open_Window(25, j, 60, j+2, Green, Black);
    write_Screen(36, j, ' Knopfmittel ', Green, Black);
    write_Screen(27, Succ(j), 'Links          Rechts', Green, Black);
    prm.io := 'I'; prm.y := 14; prm.x := 33; prm.l := 8;
    prm.komma := 4; prm.opt := 'P';
    MaskIO(prm); w1 := msk_val;
    prm.x := 50; msk_val := 0;
    MaskIO(prm); w2 := msk_val;
    If w1 > w2 Then
    Begin
      w2 := w1;
      w1 := msk_val;
    End;
    If w2-w1 < -200 Then w2 := w2+400;
    msk_val := (w1+w2)/2;
    close_Window(25, j, 60, j+2);
  End;

  Function feldinp(von, bis : Byte) : msk_rev_typ;
    (* feldinp wickelt die IO-Operationen in einer Bildschirmmaske ab *)
  Label 00, 01, 02, 99;
  Var F, i : Byte;

  Begin
00: F := von;
    Repeat
01:   get_feld(Richtung, F);      (* Wert aus Dateipuffer holen *)
      (* Vorschlagswerte unterlegen *)
      If (Satz_Art = Ziel) And (msk_val = 0) Then
      Begin
        Case F Of
          6, 7 : get_feld(0, F);  (* t,t` *)
          10 : get_feld(0, F);    (* Fernrohrhhe *)
          11 : signalhoehe;       (* Baumtafelhhe *)
          (* EDM-Hhe *)
          12 : If Not aufsatzEDM Then
               Begin
                 get_feld(Richtung, 10); msk_val := msk_val+delta_EF;
               End;
          13 : get_feld(Richtung, 11); (* Reflektorhe *)
          38 : get_feld(0, F);    (* MG *)
        End;
      End;

      If (Satz_Art = Azimut1) Then
      Begin
        Case F Of
          17 : msk_val := h_hms(hms_h(Azi3[1].MEZSoll)-hms_h(Azi3[1].UhrIst));
          20 : msk_val := h_hms(hms_h(Azi3[2].MEZSoll)-hms_h(Azi3[2].UhrIst));

          24, 27, 30, 33, 36, 40, 43, 46, 49, 52 :
            If msk_inp = #0 Then msk_inp := 'L';
          57 : If StreckenOnline And (GeraeteTyp[Azi2.MG] = 'DI') Then
               Begin
                 Blinken := True;
                 zeig_felder(F, F);
                 Blinken := False;
                 msk_val := 0; i := 0;
                 (* Streckenmessungen mitteln *)
                 If T2000_Flag Then T2000_ein;
                 Repeat
                   If Not lies_T2000 Then
                   Begin
                     msk_rev := ESC; GoTo 99;
                   End;
                   T2000.z := T2000.z*Pi/200;
                   If aufsatzEDM And (T2000.z > 0) Then
                     T2000.d := T2000.d-delta_EF*Cos(T2000.z)/Sin(T2000.z);
                   msk_val := msk_val+T2000.d;
                   i := Succ(i);
                   If Abs(msk_val/i-T2000.d) < 0.1 Then
                   Begin
                     write_screen_real(i*10+30, 25, 10, 3, T2000.d, Yellow, Black);
                   End
                   Else
                   Begin
                     msk_val := msk_val-T2000.d; Dec(i); Siren;
                   End;
                 Until i = 3;
                 If T2000_Flag Then T2000_aus;
                 msk_val := msk_val/3; Beep;
                 msk_rev := RET; Azi2.d := msk_val;
                 zeig_felder(F, F);
                 If aufsatzEDM And (T2000.z > 0) Then
                 begin
                   msk_val := Azi2.F+delta_EF/Sin(T2000.z)
                 end
                 Else msk_val := 0;
                 Azi2.E := msk_val; zeig_felder(61, 61); melde('');
                 Delay(1000);
                 msk_rev := RET; GoTo 02;
                 T2000_aus;
               End;

          15, 18, 25, 28, 31, 34, 37, 41, 44, 47, 50, 53:
            if InternalSW then
            begin
              Blinken:=True;Beep;
              Melde('              ======> Zeitstopp mit beliebiger Taste. <======');
              msk_Val:=StopSW;
              Beep;Blinken:=False;
              melde('');Delay(50);
              Beep;
            end;
          23, 26, 29, 32, 35, 38, 39, 42, 45, 48, 51, 54, 64, 65, 66, 67 :
            If T2000_Flag Then
            Begin
              T2000_ein;
              Blinken := True;
              zeig_felder(F, F);
              Blinken := False;
              If lies_T2000 Then
              Begin
                If F In [64, 65, 66, 67] Then msk_val := T2000.z
                Else msk_val := T2000.r;
                put_feld(0, F);
                zeig_felder(F, F);
                Delay(1000);
                msk_rev := RET; GoTo 02;
              End
              Else
              Begin
                msk_rev := ESC; GoTo 99;
              End;
            End;
        End (* Case *) ;
      End;

      MaskIO(msk_par[F]);

      If Satz_Art = Azimut1 Then
      Begin
        If (F In [2, 6]) And (msk_val <> 0) And (Ln(msk_val)/Ln(10) < 6) Then
        Begin
          Beep;
          melde('Kennziffer angeben'); Delay(3000); melde('');
          GoTo 01;
        End;
        If (F In [3, 7]) And (msk_val <> 0) And (Ln(msk_val)/Ln(10) < 6) Then
        Begin
          Beep;
          melde('Hochwert zu klein'); Delay(3000); melde('');
          GoTo 01;
        End;
        If (F In [24, 27, 30, 33, 36, 40, 43, 46, 49, 52]) And
        Not(msk_inp[1] In ['L', 'R', 'M', #32, #0]) Then
        Begin
          Beep; GoTo 01;
        End;
        Case msk_rev Of
          F1, F2, F3, F4, F5, ESC : GoTo 99;
        End;
      End;
      (* Temperatur testen *)
      If (Satz_Art = Ziel) And (F In [6..7]) Then
        If (msk_val <= -30) Or (msk_val >= 40) Then
        Begin
          Beep; GoTo 01;
        End;
      (* HO/HU Eingabe testen *)
      If (F = 2) And (Satz_Art = Station) And (msk_inp <> 'HO') And
      (msk_inp <> 'HU') And (Val_from_Str(msk_inp) <= 0) Then
      Begin
        Beep;
        GoTo 01;
      End;
      (* Behandlung der Abbruchinformation *)
      Case msk_rev Of
        (* nchstes Feld *)
        Down : If F < bis Then GoTo 02 Else GoTo 99;
        (* vorhergehendes Feld *)
        Up : Begin
               If F > von Then
               Begin
                 F := F-1; GoTo 01;
               End
               Else GoTo 99;
             End;
        (* normale Eingabe *)
        RET : put_feld(Richtung, F);
        (* Mesbandtaste *)
        F4 : If (F >= 34) And (F <= 37) Then
             Begin
               msk_val := messband; put_feld(Richtung, F); GoTo 01;
             End;
        (* Basislattentaste *)
        F5 : If F = 34 Then
             Begin
               msk_val := bala; put_feld(Richtung, F); GoTo 01;
             End;
        (* EDM-Taste *)
        F6 : If F = 37 Then
             Begin
               msk_val := edm; put_feld(Richtung, F); GoTo 01;
             End;
        F1,
        F2,
        ESC : GoTo 99;
      Else GoTo 01
      End;
02:   F := F+1;
    Until F > bis;
99: feldinp := msk_rev;
  End;

  Procedure zeig_felder(von, bis : Byte);
    (* IO-Felder anzeigen *)
  Const fill = '_';

  Var F, i, n : Byte;

  Begin
    For F := von To bis Do
    Begin
      get_feld(Richtung, F);
      If msk_par[F].opt In ['P', 'N', 'T'] Then
      Begin
        Str(msk_val:msk_par[F].l:msk_par[F].komma, msk_inp);
      End;
      msk_inp := Copy(msk_inp, 1, msk_par[F].l);
      If msk_inp < #32 Then msk_inp := '';
      If msk_par[F].opt = 'T' Then
      Begin
        While (msk_inp[1] <= #32) And (Length(msk_inp) > 0) Do Delete(
          msk_inp, 1, 1);
        msk_inp := Copy('000000'+msk_inp, Length(msk_inp)+1, 6);
        If msk_val = 0 Then msk_inp := '';
      End;
      write_Screen(msk_par[F].x, set_ri(msk_par[F].y), msk_inp+
                   ConstStr(msk_par[F].l-Length(msk_inp), fill), Yellow, Black);
    End;
  End;


Begin
End.
