Unit meta3;
Interface
Uses Dos, CRT, meta0, meta1, META2;

Procedure mod_400(Var x : Real);
Procedure init_buffer;
Procedure init_standpunkt;
Procedure init_zielpunkt(i : Byte);
Procedure init_station;
Procedure delta_Hoehe;
Function richtungsfehler : Real;
Procedure lies_station(rec : Integer);
Procedure lies_baumtafel;
Procedure zeig_max_ri;
Procedure schreib_station(rec : Integer);
Procedure Reduktion(satz, ziele : Byte);
Procedure satzmittel;
Function test_zenitdistanz(i : Byte) : Boolean;
Function speicher_frei : Boolean;
Function Standpunktwahl(P : Punkt_typ) : Word;
Procedure InitPdat;
Procedure LiesPdat;
Procedure SchreibPdat;
Procedure SortPdat;
Procedure SetGebiet;
Function SuchPunkt(P : Punkt_typ) : Word;
Function Punktwahl(P : Punkt_typ) : Word;
Function ReduziereStrecke(I2 : Integer) : Real;
Function NNRED(S : Real; i : Integer; pa, pe : Word) : Real;
Procedure SuchBeobachtung(Ps, P1, P2 : Punkt_typ; Var I1, I2 : Integer);

Implementation

  Procedure mod_400(Var x : Real);
    (* Richtung auf Intervall 400 GON begrenzen *)
  Begin
    Repeat
      If x >= 400 Then x := x-400;
      If x < 0 Then x := x+400;
    Until (x >= 0) And (x < 400);
  End;

  Procedure init_buffer;
    (* Dateipuffer initialisieren *)
  Var i : Byte;
  Begin
    Case Satz_Art Of
      Auftrag :
        Begin
          Buffer.Au.Aktenz := '';
          Buffer.Au.Arb_Plan := '';
          Buffer.Au.Gemarkung := '';
          Buffer.Au.Beobachter := '';
          Buffer.Au.LVBernr := 49;
          Buffer.Au.MetaBernr := 0;
          For i := 1 To 10 Do Buffer.Au.TK25[i] := 0;
        End;
      Geraet :
        Begin
          Buffer.Ge.Index := 0;
          Buffer.Ge.Nummer := '';
          Buffer.Ge.Name := '';
          Buffer.Ge.Kennung := '';
          Buffer.Ge.A := 0;
          Buffer.Ge.B := 0;
          Buffer.Ge.C := 0;
          Buffer.Ge.d := 0;
          For i := 1 To 3 Do
          Begin
            Buffer.Ge.Sig[i].bp := '';
            Buffer.Ge.Sig[i].r0 := 0;
            Buffer.Ge.Sig[i].h0 := 0;
            Buffer.Ge.Sig[i].Hub := 0;
            Buffer.Ge.Sig[i].Al := 0;
          End;
        End;
    End;
    Buffer.art := Satz_Art;
  End;

  Procedure init_standpunkt;
    (* Standpunkt initialisieren *)
  Begin
    With Standpunkt Do
    Begin
      Ps := '';
      Pfeiler := 'HO';
      p_ps := 0;
      Zeit := 0;
      Tag := 0;
      Bem := '';
      Richtungen := 0;
      Saetze := 0;
      Zeilen := -1;
      mr := 0;
    End;
  End;

  Procedure init_zielpunkt(i : Byte);
    (* Zielpunkt initialisieren *)
  Var j : Byte;
  Begin
    With Zielpunkt[i] Do
    Begin
      Pz := '';
      p_Pz := 0;
      tt := 0; tf := 0;
      Bem := '';
      rm := 0;
      For j := 0 To max_Satz Do
      Begin
        Ri[j, 1] := 0; Ri[j, 2] := 0; Ri[j, 3] := 0;
      End;
      F := 0; T := 0; E := 0; r := 0;
      zd := 0; z1 := 0; z2 := 0; z3 := 0; z4 := 0; zi := 0; zv := 0;
      S := 0; seitw := 0; exz := 0; d := 0; MG := 0; dH := 0;
    End;
  End;

  Procedure init_station;
    (* Beobachtungsstation initialisieren *)
  Var i : Byte;
  Begin
    init_standpunkt;
    For i := 0 To max_Richtung Do init_zielpunkt(i);
    merk_rec := 0; Richtung := 0; ErstRichtung := 0;
  End;


  Procedure delta_Hoehe;
    (* Hhenunterschied und Luftdruckkorrektur rechnen *)
  Var z : Real;
  Begin

    With Zielpunkt[Richtung] Do
    Begin
      If zd > 0 Then
        If S > 0 Then
          dH := (S+exz)*Cos(zd*Pi/200)/Sin(zd*Pi/200)+Sqr(S+exz)*0.68166E-7+F-T
        Else
          If d > 0 Then
          Begin
            If Pos(GeraeteTyp[MG], 'MB') > 0 Then
            Begin
              E := F; r := T;
            End;
            z := zd+arcsin(((E-r)-(F-T)-0.68166E-7*Sqr(d+GerKonst[MG].C))*
                           Sin(zd*Pi/200)/(d+GerKonst[MG].C))*200/Pi;
            dH := (d+GerKonst[MG].C)*Cos(z*Pi/200)+E-r;
            If Pos(GeraeteTyp[MG], 'MB') > 0 Then
            Begin
              E := 0; r := 0;
            End;
          End;
      If (dH <> 0) And (p_Pz = 0) And (Pos(GeraeteTyp[MG], 'HPDIGM') > 0) Then
        p_Pz := Standpunkt.p_ps-(dH-E+r)/2*Standpunkt.p_ps/8019/(1+tt*0.00367);
    End;
  End;

  Function richtungsfehler : Real;
    (* Mittleren Richtungsfehler berechnen *)
  Var i, S : Byte;
    d, sumd, sumd2, vv : Real;
  Begin
    sumd2 := 0; vv := 0; richtungsfehler := 0;
    If (Standpunkt.Richtungen > 0) And (Standpunkt.Saetze > 0) Then
    Begin
      For S := 0 To Pred(Standpunkt.Saetze) Do
      Begin
        sumd := 0;
        For i := 0 To Standpunkt.Richtungen Do
        Begin
          d := Zielpunkt[i].Ri[S, 3]-Zielpunkt[i].rm;
          sumd := sumd+d; vv := vv+d*d;
        End;
        sumd2 := sumd2+sumd*sumd;
      End;
      vv := vv-sumd2/(Standpunkt.Richtungen+1);
      If Standpunkt.Saetze > 1 Then
        richtungsfehler := Sqrt(vv/Standpunkt.Richtungen/
                                (Standpunkt.Saetze-1)/(Standpunkt.Saetze))
      Else richtungsfehler := 0;
    End;
  End;

  Procedure lies_station(rec : Integer);
    (* Station aus Datei lesen *)
  Var i : Integer;
  Begin
    init_station; merk_rec := rec;
    Seek(Datei, rec); Read(Datei, Buffer);
    Case Buffer.art Of
      Station :
        Begin
          Standpunkt := Buffer.St;
          For i := 0 To Standpunkt.Zeilen Do
          Begin
            Inc(rec); Seek(Datei, rec); Read(Datei, Buffer);
            Zielpunkt[i] := Buffer.zi;
          End;
        End;
      Azimut1 :
        Begin
          Azi1 := Buffer.Az1;
          Read(Datei, Buffer);
          Azi2 := Buffer.Az2;
          Read(Datei, Buffer);
          Azi3[1] := Buffer.Az3;
          Read(Datei, Buffer);
          Azi3[2] := Buffer.Az3;
        End;
    End;
  End;

  Procedure lies_baumtafel;
    (* Baumtafeldaten in Array lesen *)
  Var i, j, k : Byte;
  Begin
    Satz_Art := Geraet; k := 0;
    For i := 1 To max_Geraet Do
    Begin
      Seek(Datei, i); Read(Datei, Buffer);
      For j := 1 To 3 Do
      Begin
        k := Succ(k);
        bt[k].bp := Buffer.Ge.Sig[j].bp;
        bt[k].r0 := Buffer.Ge.Sig[j].r0;
        bt[k].h0 := Buffer.Ge.Sig[j].h0;
        bt[k].Hub := Buffer.Ge.Sig[j].Hub;
        bt[k].Al := Buffer.Ge.Sig[j].Al;
        If bt[k].Al = 0 Then bt[k].Al := 1;
      End;
    End;
  End;

  Procedure zeig_max_ri;
    (* Station bis zum Displayende anzeigen *)

  Var r : Integer;
  Begin
    For r := 9 To 23 Do
    Begin
      write_Screen(2, r, ConstStr(78, ' '), Red, Black);
    End;
    Satz_Art := Ziel;
    Richtung := 0; ErstRichtung := 0;
    r := Standpunkt.Zeilen;
    If (r < 0) Or (r >= Pred(max_ri)) Then r := Pred(max_ri);
    Standpunkt.mr := richtungsfehler;
    write_screen_real(68, 7, 6, 2, Standpunkt.mr*1e3, Yellow, Black);
    zeig_felder(1, 4);
    Richtung := -1;
    Repeat
      Inc(Richtung);
      zeig_felder(5, max_Felder);
      write_screen_int(2, set_ri(9), 2, Richtung, Yellow, Black);
    Until Richtung = r;
    Richtung := -1;
  End;


  Procedure schreib_station(rec : Integer);
    (* Station in Datei schreiben *)
  Const Diskettenfehler = 'Disketten-Schreibfehler!';
  Var ziele, i : Integer;
    msg : String[12];

    Function CheckStation(Var i : Integer) : Boolean;
    Var j : Integer;
    Begin
      CheckStation := False;
      If Standpunkt.Ps = '' Then Exit;
      For j := 0 To Standpunkt.Zeilen Do
      Begin
        With Zielpunkt[j] Do
        Begin
          i := j;
          If Pz = '' Then Exit;
          If (d = 0) And (S = 0) Then
          Begin
            MG := 0; tt := 0; tf := 0; p_Pz := 0;
          End;
          If (d > 0) And (Pos(GeraeteTyp[MG], EDMTypen) > 0) And (p_Pz = 0) Then Exit;
          If (zd > 0) And (F = 0) Then Exit;
          If (d > 0) And (S = 0) And (GeraeteTyp[MG] = 'BL') Then Exit;
          If ((d > 0) Or (S > 0)) And (GeraeteTyp[MG] = '') Then Exit;
        End;
      End;
      CheckStation := True;
    End;

  Begin
    If rec = 0 Then
    Begin
      ziele := -1;
      While Zielpunkt[Succ(ziele)].Pz <> '' Do Inc(ziele);
      Standpunkt.Zeilen := ziele;
      rec := FileSize(Datei);
    End
    Else ziele := Standpunkt.Zeilen;
    i := 0;
    If Not CheckStation(i) Then
    Begin
      If i = 0 Then msg := 'Standpunkt'
      Else msg := Zielpunkt[i].Pz;
      If Not JaNein('Fehler bei '+msg+'. - Speichern') Then Exit;
    End;
    If ziele >= 0 Then
    Begin
      (*  Punktzeiger aktualisieren *)
      i := 0;
      Repeat
        i := Succ(i);
      Until (PunktZeiger[i].rec = rec) Or (i = Succ(stationen));
      If i = Succ(stationen) Then stationen := Succ(stationen);
      PunktZeiger[i].pkt := Standpunkt.Ps;
      PunktZeiger[i].rec := rec;
      If Satz_Art = Azimut1 then PunktZeiger[i].Art := 'A'
      else PunktZeiger[i].Art := #32;

      Seek(ZeigerFile, i);
        (*$I-*)
      Write(ZeigerFile, PunktZeiger[i]);
        (*$I+*)
      If IoResult > 0 Then
      Begin
        melde(Diskettenfehler); Siren;
        Repeat Until KeyPressed; Exit;
      End;
      Seek(Datei, rec);
      Buffer.art := Station; Buffer.St := Standpunkt; Write(Datei, Buffer);
      Buffer.art := Ziel;
      For Richtung := 0 To ziele Do
      Begin
        delta_Hoehe;
        rec := Succ(rec); Seek(Datei, rec);
        Buffer.zi := Zielpunkt[Richtung];
            (*$I-*) Write(Datei, Buffer); (*$I+*)
        If IoResult > 0 Then
        Begin
          melde(Diskettenfehler); Siren;
          Repeat Until KeyPressed; Exit;
        End;
      End;
      melde('Daten gespeichert!'); Beep; warten(1);
      init_station; merk_rec := 0;
      Close(Datei);
      msk_inp := Projekt+'.BEO';
      Assign(Datei, msk_inp);
      Reset(Datei);
      Close(ZeigerFile);
      msk_inp := Projekt+'.PTR';
      Assign(ZeigerFile, msk_inp);
      Reset(ZeigerFile);
      merk_rec := 0;
    End
    Else UserError;
  End;

  Procedure Reduktion(satz, ziele : Byte);
    (* Satzreduktion auf Nullrichtung *)
  Var i : Byte;
    r0, dr : Real;
  Begin
    If Standpunkt.Saetze > 0 Then
    Begin
      With Zielpunkt[0] Do
      Begin
        If Ri[satz, 2] > Ri[satz, 1] Then dr := -200 Else dr := 200;
        r0 := (Ri[satz, 1]+Ri[satz, 2]+dr+2000)/2-1000; Ri[satz, 3] := 0;
      End;
      For i := 1 To ziele Do
      Begin
        With Zielpunkt[i] Do
        Begin
          If Ri[satz, 2] > Ri[satz, 1] Then dr := -200 Else dr := 200;
          Ri[satz, 3] := (Ri[satz, 1]+Ri[satz, 2]+dr+2000)/2-1000;
          Ri[satz, 3] := Ri[satz, 3]-r0;
          mod_400(Ri[satz, 3]);
        End;
      End;
    End;
  End;

  Procedure satzmittel;
    (* Satzmittel aus allen Stzen bilden *)
  Var r, satz : Byte;
    dr : Real;
  Begin
    If Standpunkt.Saetze > 0 Then
    Begin
      For r := 0 To Standpunkt.Richtungen Do
      Begin
        With Zielpunkt[r] Do
        Begin
          rm := 0;
          For satz := 0 To Standpunkt.Saetze-1 Do
          Begin
            dr := Ri[satz, 3]-Ri[0, 3];
            rm := rm+Ri[satz, 3];
            If dr < -300 Then rm := rm+400;
            If dr > 300 Then rm := rm-400;
          End;
          rm := rm/(Standpunkt.Saetze);
          mod_400(rm);
        End;
      End;
    End;
  End;

  Function test_zenitdistanz(i : Byte) : Boolean;
    (* Zenitdistanzmessung auswerten *)
  Const faden = 0.3183;           (* Fadenkonstante *)
  Var x : Real;
  Begin
    test_zenitdistanz := False;
    With Zielpunkt[i] Do
    Begin
      If z1 > 200 Then
      Begin
        x := z1; z1 := z3; z3 := x;
      End;
      If z2 > 200 Then
      Begin
        x := z2; z2 := z4; z4 := x;
      End;
      If Abs(z1-z2-z3+z4) < faden Then
        If (Abs(z1+z3-400) < diff_index) And
        ((Abs(z2+z4-400)-2*faden) < diff_index) Then
          If (z3 > z1) And (z4 > z2) Then
            If Abs(z1-z3-z2+z4)/4 < max_v Then test_zenitdistanz := True;
      If z1 > 0 Then
      Begin
        zd := (800+z1-z3+z2-z4)/4;
        zi := (400-z1-z3)/2;
        zv := (400+z3-z4-(400+z1-z2))/4;
        delta_Hoehe;
      End;
    End;
  End;

  Function speicher_frei : Boolean;
  Var Ch : Char;
  Begin
    speicher_frei := True;
    If (merk_rec > 0) Or (Standpunkt.Zeilen >= 0) Then
    Begin
      Repeat
        melde('Daten nicht gesichert! (A)nzeigen, (S)ichern, (L)schen ? ');
        Siren; Ch := Readkey; Ch := Upcase(Ch); Write(Ch);
      Until Ch In ['A', 'L', 'S'];
      Case Ch Of
        'S' : schreib_station(merk_rec);
        'A' : speicher_frei := False;
        'L' : Begin
                init_station; merk_rec := 0;
              End;
      End;
    End;
  End;

  Function Standpunktwahl(P : Punkt_typ) : Word;
  Const x1 = 30; y1 = 6; x2 = 47; y2 = 17;
  Var i, m, n : Integer;
    Par : msk_par_typ;
  Begin
    Standpunktwahl := 0;
    If stationen = 0 Then
    Begin
      UserError;
      Exit;
    End;
    open_Window(x1, y1, x2, y2, Green, Black);
    write_Screen(x1+1, y1, ' Standpunkte ', LightGreen, Black);
    n := 0;
    If P <> '' Then
      Repeat
        Inc(n);
      Until (PunktZeiger[n].pkt = P) Or (n > stationen)
    Else n := 1;

    If PunktZeiger[n].pkt <> P Then n := 0;
    Par.io := 'O'; Par.l := 11; Par.komma := 0;
    Par.y := y1;
    Par.x := x1+3;
    Par.opt := 'U';
    i := n-5; m := 6;
    If i < 0 Then
    Begin
      i := 0; m := 10;
    End;

    Repeat
      Inc(Par.y); Inc(i);
      msk_inp := PunktZeiger[i].pkt; msk_val := 0;
      scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
      write_screen(x2-2,par.y,PunktZeiger[i].Art,Yellow,Black);
      MaskIO(Par);
    Until (i = n+m) Or (i = stationen);
    Par.y := Par.y-i+n;
    If n < 1 Then
    Begin
      Inc(Par.y); n := 1;
    End;
    Repeat
      Par.io := 'I';
      msk_inp := PunktZeiger[n].pkt; msk_val := 0;
      write_Screen(x1+1, Par.y, '->', LightRed, Black);
      write_screen(x2-2, Par.y,PunktZeiger[n].Art,Yellow,Black);
      MaskIO(Par);
      write_Screen(x1+1, Par.y, '  ', LightRed, Black);
      Case msk_rev Of
        ESC : Begin
                close_Window(x1, y1, x2, y2);
                Exit;
              End;
        RET : Begin
                Standpunktwahl := PunktZeiger[n].rec;
                close_Window(x1, y1, x2, y2);
                Exit;
              End;
        Up : If n > 1 Then
             Begin
               Dec(n);
               Dec(Par.y);
               scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
             End;
        PgUp : For i := 1 To 10 Do
                 If n > 1 Then
                 Begin
                   Dec(n); Dec(Par.y);
                   scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
                   Par.io := 'O'; msk_inp := PunktZeiger[n].pkt;
                   write_screen(x2-2, Par.y,PunktZeiger[n].Art,Yellow,Black);
                   MaskIO(Par);
                 End;
        Down : If n < stationen Then
               Begin
                 Inc(n);
                 Inc(Par.y);
                 scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
               End;
        PgDown :
          For i := 1 To 10 Do
            If n < stationen Then
            Begin
              Inc(n); Inc(Par.y);
              scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
              Par.io := 'O'; msk_inp := PunktZeiger[n].pkt;
              write_screen(x2-2, Par.y,PunktZeiger[n].Art,Yellow,Black);
              MaskIO(Par);
            End;
      End;
    Until False;
  End;

  Procedure InitPdat;
  Var i : Word;
  Begin
    For i := 0 To MaxPdat Do
    Begin
      Pdat[i] := Nil;
    (*
    Pdat[i].P:='';Pdat[i].Y:=0;Pdat[i].X:=0;Pdat[i].HO:=0;Pdat[i].HU:=0;
    *)
    End;
    MaxP := 0;
  End;

  Procedure LiesPdat;
  Var Name : String[64];
    Pdatei : File Of VermPunkt_Typ;
  Begin
    MaxP := 0;
    Name := Projekt+'.PKT';
    melde(Name+' lesen.');
    Assign(Pdatei, Name);
  {$I-}
    Reset(Pdatei);
  {$I+}
    If IoResult = 0 Then
    Begin
      While Not EoF(Pdatei) And (MaxP < MaxPdat) And (MaxAvail > 50) Do
      Begin
        Inc(MaxP);
        New(Pdat[MaxP]); Read(Pdatei, Pdat[MaxP]^);
      End;
      Close(Pdatei);
    End;
    melde('');
  End;

  Procedure SchreibPdat;
  Var Name : String[64];
    Pdatei : File Of VermPunkt_Typ;
  Var i : Word;
  Begin
    Name := Projekt+'.PKT';
    Assign(Pdatei, Name);
  {$I-}
    Rewrite(Pdatei);
  {$I+}
    If IoResult = 0 Then
    Begin
      For i := 1 To MaxP Do Write(Pdatei, Pdat[i]^);
      Close(Pdatei);
    End
    Else melde('Fehler beim Schlieen der Datei '+Name);
    For i := 1 To MaxP Do Dispose(Pdat[i]);
  End;

  Procedure SortPdat;

    Function LVTyp(P : Punkt_typ) : String;
    Var i : Integer;
      y : String;
      x : Real;
      (* Punktnummer fuer Sortierung umbauen *)
    Begin
      i := Pos('/', P); If i > 0 Then P[i] := '.';
      y := '';
      (* Ziffern und . extrahieren *)
      For i := 3 To Length(P) Do
        If P[i] In ['.', '0'..'9'] Then y := y+P[i];
      (* Nummer formatieren *)
      Val(y, x, i); Str(x:8:3, y);
      (* Die beiden ersten Zeichen wieder vor die Nummer setzen *)
      y := Copy(P, 1, 2)+y;
      (* Buchstabe am Schlu der Punktnummer wieder anhaengen *)
      If P[Length(P)] In ['A'..'z'] Then y := y+P[Length(P)];
      LVTyp := y;
    End;

    Procedure sort(l, r : Integer);
    Var
      i, j : Integer;
      x, y : VermPunkt_Typ;
    Begin
      i := l; j := r; x := Pdat[(l+r) Div 2]^;
      Repeat
        While LVTyp(Pdat[i]^.P) < LVTyp(x.P) Do i := i+1;
        While LVTyp(x.P) < LVTyp(Pdat[j]^.P) Do j := j-1;
        If i <= j Then
        Begin
          y := Pdat[i]^; Pdat[i]^ := Pdat[j]^; Pdat[j]^ := y;
          i := i+1; j := j-1;
        End;
      Until i > j;
      If l < j Then sort(l, j);
      If i < r Then sort(i, r);
    End;

  Begin
    sort(1, MaxP);
  End;

  Procedure SetGebiet;
  Var i, n : Word;
  Begin
    YGebiet := 0; Hgebiet := 0;
    For i := 1 To MaxP Do
    Begin
      YGebiet := YGebiet+Pdat[i]^.y;
      If Pdat[i]^.HO > 0 Then
      Begin
        Hgebiet := Hgebiet+Pdat[i]^.HO;
        Inc(n);
      End
      Else
        If Pdat[i]^.HU > 0 Then
        Begin
          Hgebiet := Hgebiet+Pdat[i]^.HU;
          Inc(n);
        End;
    End;
    If MaxP > 0 Then YGebiet := YGebiet/MaxP Else YGebiet := 500000;
    If n > 0 Then Hgebiet := Hgebiet/n Else Hgebiet := 0;
  End;

  Function SuchPunkt(P : Punkt_typ) : Word;
  Var i : Integer;
  Begin
    i := 0;
    Repeat
      Inc(i);
    Until (Pdat[i]^.P = P) Or (i > MaxP);
    If Pdat[i]^.P = P Then SuchPunkt := i Else SuchPunkt := 0;
  End;

  Function Punktwahl(P : Punkt_typ) : Word;
  Const x1 = 30; y1 = 6; x2 = 45; y2 = 17;
  Var i, m, n : Integer;
    Par : msk_par_typ;
  Begin
    Punktwahl := 0;
    If MaxP = 0 Then
    Begin
      UserError;
      Exit;
    End;
    open_Window(x1, y1, x2, y2, Green, Black);
    write_Screen(x1+1, y1, ' Punkte ', LightGreen, Black);
    n := 0;
    If P <> '' Then
    Repeat
      Inc(n);
    Until (Pdat[n]^.P = P) Or (n > MaxP)
    Else n := 1;

    If Pdat[n]^.P <> P Then n := 0;
    Par.io := 'O'; Par.l := 11; Par.komma := 0;
    Par.y := y1;
    Par.x := x1+3;
    Par.opt := 'U';
    i := n-5; m := 6;
    If i < 0 Then
    Begin
      i := 0; m := 10;
    End;
    Repeat
      Inc(Par.y); Inc(i);
      msk_inp := Pdat[i]^.P; msk_val := 0;
      scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
      MaskIO(Par);
    Until (i = n+m) Or (i = MaxP);
    Par.y := Par.y-i+n;
    If n = 0 Then
    Begin
      Inc(Par.y); n := 1;
    End;
    Repeat
      Par.io := 'I';
      msk_inp := Pdat[n]^.P; msk_val := 0;
      write_Screen(x1+1, Par.y, '->', LightRed, Black);
      MaskIO(Par);
      write_Screen(x1+1, Par.y, '  ', LightRed, Black);
      Case msk_rev Of
        ESC : Begin
                close_Window(x1, y1, x2, y2);
                Exit;
              End;
        RET : Begin
                Punktwahl := n;
                close_Window(x1, y1, x2, y2);
                Exit;
              End;
        Up : If n > 1 Then
             Begin
               Dec(n);
               Dec(Par.y);
               scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
             End;
        PgUp : For i := 1 To 10 Do
                 If n > 1 Then
                 Begin
                   Dec(n); Dec(Par.y);
                   scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
                   Par.io := 'O'; msk_inp := Pdat[n]^.P;
                   MaskIO(Par);
                 End;
        Down : If n < MaxP Then
               Begin
                 Inc(n);
                 Inc(Par.y);
                 scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
               End;
        PgDown :
          For i := 1 To 10 Do
            If n < MaxP Then
            Begin
              Inc(n); Inc(Par.y);
              scroll(Par.y, y1+1, y2-1, x1+1, x2-1, 1);
              Par.io := 'O'; msk_inp := Pdat[n]^.P;
              MaskIO(Par);
            End;
      End;
    Until False;
  End;

  Function ReduziereStrecke(I2 : Integer) : Real;
  Begin
    ReduziereStrecke := 0;
    If Zielpunkt[I2].d > 0 Then
    Begin
      With Zielpunkt[I2] Do
      Begin
        If (zd > 0) And (d > 0) Then
        Begin
          If Pos(GeraeteTyp[MG], 'HPDIGM') > 0 Then
          Begin
            zd := zd+arcsin(((E-r)-(F-T)-0.68166E-7*Sqr(d+GerKonst[MG].C))*
                            Sin(zd*Pi/200)/(d+GerKonst[MG].C))*200/Pi;
            d := d+ATM(d, tt, p_Pz, MG);
          End;
          ReduziereStrecke := (d+GerKonst[MG].C)*Sin(zd*Pi/200)+exz;
        End;
      End;
    End;
  End;

  Procedure Warnung(S : str80);
  Begin
    Siren;
    write_Screen(1, 24, 'WARNUNG: '+S, LightRed, Black);
    Delay(3000);
    write_Screen(1, 24, ConstStr(80, ' '), Black, Black);
  End;

  Function NNRED(S : Real; i : Integer; pa, pe : Word) : Real;
  Const Rad = 6381438.5;
  Var YR, YG, HM, HG, HR : Real;
  Begin
    NNRED := S; YR := 0; YG := 0; HG := 0; HR := 0;
    If pa > 0 Then
    Begin
      YG := Pdat[pa]^.y;
      If Pdat[pa]^.HO > 0 Then HG := Pdat[pa]^.HO
      Else If Pdat[pa]^.HU > 0 Then HG := Pdat[pa]^.HU;
    End;
    If pe > 0 Then
    Begin
      YR := Pdat[pe]^.y;
      If Pdat[pe]^.HO > 0 Then HR := Pdat[pe]^.HO
      Else If Pdat[pe]^.HU > 0 Then HR := Pdat[pe]^.HU;
    End;

    If (YR = 0) And (YG > 0) Then YR := YG;
    If (YG = 0) And (YR > 0) Then YG := YR;
    If (YG = 0) And (YR = 0) Then
    Begin
      YG := YGebiet;
      Warnung('Rechtswert bei Streckenreduktion geschtzt.');
    End;
    YG := YG-500000.0; YR := YR-500000.0;

    If HG > 0 Then HM := HG+Zielpunkt[i].E+Zielpunkt[i].dH/2
    Else HM := HR+Zielpunkt[i].r-Zielpunkt[i].dH/2;
    If (HG = 0) And (HR = 0) Then
    Begin
      HM := Hgebiet;
      Warnung('Hhe bei Streckenreduktion geschtzt.');
    End;
    NNRED := S*(1.0-HM/Rad)*(1.0+(YG*YG+YG*YR+YR*YR)/6.0/Rad/Rad);
  End;

  Procedure SuchBeobachtung(Ps, P1, P2 : Punkt_typ; Var I1, I2 : Integer);
  Var i, j : Integer;
  Begin
    i := 0; I1 := -1; I2 := -1;
    If stationen > 0 Then
    Begin
      Repeat
        Repeat
          Inc(i);
        Until (PunktZeiger[i].pkt = Ps) Or (i = stationen);

        If PunktZeiger[i].pkt = Ps Then
        Begin
          lies_station(PunktZeiger[i].rec);
          I1 := -1; I2 := -1;
          For j := 0 To Standpunkt.Richtungen Do
          Begin
            If Zielpunkt[j].Pz = P1 Then If I1 < 0 Then I1 := j;
            If Zielpunkt[j].Pz = P2 Then If I2 < 0 Then I2 := j;
          End;
        End;

      Until (I1 >= 0) And ((I2 >= 0) Or (P2 = '')) Or (i = stationen);
    End;
  End;

Begin
End.
