Unit meta7;
{$F+,O+}
Interface
Uses Dos, CRT, meta0, meta1, META2, meta3;
Procedure SonnenAzimut;
Procedure Sonnenpolynom;
Procedure SetSystemClock;

Implementation

  Procedure SonnenAzimut;
  Var
    rev : msk_rev_typ;
    i : Word;
    MessMode : Char;
    zi,zv:real;

    Procedure InitAzimut;
    Var i, j : Word;
    Begin
      With Azi1 Do
      Begin
        Ps := '';
        YS := 0; XS := 0; HS := 0; LS := 0; BS := 0; cS := 0;
        Pz := '';
        YZ := 0; XZ := 0; HZ := 0; LZ := 0; BZ := 0; cZ := 0;
        Bem := '';
        Datum := 0;
        t1 := 0; t2 := 0; tm := 0;
      End;

      With Azi2 Do
      Begin
        S := 0; dH := 0; d := 0;
        Druck := 0; Temp := 0;
        F := 0; T := 0; E := 0; r := 0;
        z := 0; z1 := 0; z2 := 0; z3 := 0; z4 := 0;
      End;

      For i := 1 To 2 Do
        With Azi3[i] Do
        Begin
          RZ := 0;
          MEZSoll := 0; UhrIst := 0; DeltaU := 0;
          For j := 1 To 5 Do
          Begin
            RH[j].Rand := #0;
            RH[j].Ri := 0; RH[j].Uhr := 0; RH[j].MEZ := 0; RH[j].ti := 0; RH[j].v := 0;
          End;
        End;
       zi:=0;zv:=0;
    End;

    Procedure ZeigAzimut;
    Var i : Word;
    Begin
      Satz_Art := Azimut1;
      zeig_felder(1, max_Felder);
      For i := 1 To 5 Do
      Begin
        If Azi3[1].RH[i].Uhr > 0 Then
        Begin
          write_screen_real(27, i+11, 7, 6, h_hms(Azi3[1].RH[i].MEZ), Yellow, Black);
          write_screen_real(37, i+11, 8, 4, Azi3[1].RH[i].ti, Yellow, Black);
          write_screen_real(47, i+11, 7, 2, Azi3[1].RH[i].v*1E3, Yellow, Black);
        End;
        If Azi3[2].RH[i].Uhr > 0 Then
        Begin
          write_screen_real(27, i+17, 7, 6, h_hms(Azi3[2].RH[i].MEZ), Yellow, Black);
          write_screen_real(37, i+17, 8, 4, Azi3[2].RH[i].ti, Yellow, Black);
          write_screen_real(47, i+17, 7, 2, Azi3[2].RH[i].v*1E3, Yellow, Black);
        End;
      End;
      write_screen_real(37, 17, 8, 4, Azi1.t1, Yellow, Black);
      write_screen_real(37, 23, 8, 4, Azi1.t2, Yellow, Black);
      if Azi2.z1>0 then
      begin
        zi := (400-Azi2.z1-Azi2.z3)/2;
        zv := (400+Azi2.z3-Azi2.z4-(400+Azi2.z1-Azi2.z2))/4;
        write_screen_real(61, 19, 8, 0, zi*1E4, LightRed, Black);
        write_screen_real(71, 19, 8, 0, zv*1E4, LightRed, Black);
      end;
    End;

    Function test_zenit : Boolean;
      (* Zenitdistanzmessung auswerten *)
    Const faden = 0.3183;         (* Fadenkonstante *)
    Var x : Real;
    Begin
      test_zenit := False;
      If Azi2.z1 > 200 Then
      Begin
        x := Azi2.z1; Azi2.z1 := Azi2.z3; Azi2.z3 := x;
      End;
      If Azi2.z2 > 200 Then
      Begin
        x := Azi2.z2; Azi2.z2 := Azi2.z4; Azi2.z4 := x;
      End;
      If Abs(Azi2.z1-Azi2.z2-Azi2.z3+Azi2.z4) < faden Then
        If (Abs(Azi2.z1+Azi2.z3-400) < diff_index) And
        ((Abs(Azi2.z2+Azi2.z4-400)-2*faden) < diff_index) Then
          If (Azi2.z3 > Azi2.z1) And (Azi2.z4 > Azi2.z2) Then
            If Abs(Azi2.z1-Azi2.z3-Azi2.z2+Azi2.z4)/4 < max_v Then test_zenit := True;

      If Azi2.z1 > 0 Then
      Begin
        Azi2.z := (800+Azi2.z1-Azi2.z3+Azi2.z2-Azi2.z4)/4;
        zi := (400-Azi2.z1-Azi2.z3)/2;
        zv := (400+Azi2.z3-Azi2.z4-(400+Azi2.z1-Azi2.z2))/4;
        write_screen_real(61, 19, 8, 0, zi*1E4, LightRed, Black);
        write_screen_real(71, 19, 8, 0, zv*1E4, LightRed, Black);
      End;
    End;

    Procedure gauss_geografisch(r, h : Real; Var l, B, C : Real);
    Const aa = 6377397.155;       (* Grosse Halbachse Bessel-Ellipsoid *)
      bb = 6356078.963;           (* Kleine Halbachse Bessel-Ellipsoid *)
    Var bf, nf, tf, ym, bm, cm, mm, lm, y2, y3, y4, nf2, nf3, nf4, m : Real;
      nullmeridian, kennziffer : Integer;
      c_pol, e2 : Real;


      Function breite(g : Real) : Real;
    (* Eingabe: Fusspunktbreite g in m
       Ausgabe: Gradbogen in Dezimalaltgradad
    *)
      Var k0, k2, k4, k6, e4, e6, e8, B : Real;
      Begin
        e4 := e2*e2;
        e6 := e4*e2;
        e8 := e6*e2;
        k0 := c_pol*(1-3/4*e2+45/64*e4-175/256*e6+11025/16384*e8);
        k2 := (3/8*e2-3/16*e4+213/2048*e6-255/4096*e8);
        k4 := (21/256*e4-21/256*e6+533/8192*e8);
        k6 := (151/6144*e6-453/12288*e8);
        g := g/k0;
        B := g+k2*Sin(2*g)+k4*Sin(4*g)+k6*Sin(6*g);
        breite := B*180/Pi;
      End;

    Begin
      e2 := (Sqr(aa)-Sqr(bb))/Sqr(bb);
      c_pol := aa*aa/bb;
      kennziffer := Trunc(r/1E6);
      r := r-(kennziffer*1E6+500000.0);
      y2 := r*r; y3 := y2*r; y4 := y2*y2;
      bf := breite(h)*Pi/180;
      tf := tan(bf);
      nf := c_pol/Sqrt(1+e2*Sqr(Cos(bf)));
      nf2 := nf*nf; nf3 := nf2*nf; nf4 := nf3*nf;

      ym := 2*(ArcTan(power(Exp(1), r/nf))-Pi/4);
      cm := ArcTan(Sin(ym)*tf);
      bm := arcsin(Cos(ym)*Sin(bf));
      mm := 1/Cos(ym);
      lm := ArcTan(tan(ym)/Cos(bf));

      B := bm-e2/2/nf2*Sqr(Cos(bf))*tf*y2
      +e2/4/nf4*Sqr(Cos(bf))*tf*(1-Sqr(tf))*y4;
      l := lm-e2/3/nf3*Cos(bf)*y3;
      C := cm+e2/3/nf3*Sqr(Cos(bf))*tf*y3;
      m := mm+e2/2/nf2*Sqr(Cos(bf))*y2;
      B := B*180/Pi;
      l := l*180/Pi+kennziffer*3;
      C := C*200/Pi;
    End;


    Procedure Koordinatenumformung;
    Var i : Word;
      m, ta, sa : Real;
    Begin
      If (Azi1.YS > 0) Then
      Begin
        gauss_geografisch(Azi1.YS, Azi1.XS, Azi1.LS, Azi1.BS, Azi1.cS);
        Azi1.LS := h_hms(Azi1.LS);
        Azi1.BS := h_hms(Azi1.BS);
        Azi1.cS := Azi1.cS;
      End;
      If (Azi1.YZ > 0) Then
      Begin
        gauss_geografisch(Azi1.YZ, Azi1.XZ, Azi1.LZ, Azi1.BZ, Azi1.cZ);
        Azi1.LZ := h_hms(Azi1.LZ);
        Azi1.BZ := h_hms(Azi1.BZ);
        Azi1.cZ := Azi1.cZ;
      End;
      If (Azi1.YS > 0) And (Azi1.YZ > 0) And (Azi1.XS > 0) And (Azi1.XZ > 0) Then
      Begin
        ta := Azi1.YZ-Azi1.YS;
        sa := Azi1.XZ-Azi1.XS;
        R_P(ta, sa);
        write_screen_real(59, 5, 8, 4, ta*200/Pi, Green, Black);
        write_screen_real(70, 5, 9, 3, sa, Green, Black);
      End;
    End;

    Procedure Zeitreduktion;
    Var i : Word;
      dU : Real;
    Begin
      dU := 0;
      If (Azi3[1].DeltaU <> 0) And (Azi3[2].DeltaU <> 0) Then
        dU := (hms_h(Azi3[1].DeltaU)+hms_h(Azi3[2].DeltaU))/2
      Else
        If Azi3[1].DeltaU <> 0 Then dU := hms_h(Azi3[1].DeltaU)
      Else
        If Azi3[2].DeltaU <> 0 Then dU := hms_h(Azi3[2].DeltaU);

      For i := 1 To 5 Do
      Begin
        If Azi3[1].RH[i].Uhr > 0 Then
        Begin
          Azi3[1].RH[i].MEZ := hms_h(Azi3[1].RH[i].Uhr)+dU;
          write_screen_real(27, i+11, 7, 6, h_hms(Azi3[1].RH[i].MEZ), Yellow, Black);
        End
        Else
        Begin
          Azi3[1].RH[i].MEZ := 0;
          write_screen_real(27, i+11, 9, 6, 0, Yellow, Black);
        End;
        If Azi3[2].RH[i].Uhr > 0 Then
        Begin
          Azi3[2].RH[i].MEZ := hms_h(Azi3[2].RH[i].Uhr)+dU;
          write_screen_real(27, i+17, 7, 6, h_hms(Azi3[2].RH[i].MEZ), Yellow, Black);
        End
        Else
        Begin
          Azi3[2].RH[i].MEZ := 0;
          write_screen_real(27, i+17, 9, 6, 0, Yellow, Black);
        End;
      End;

    End;

    Procedure Azimutberechnung;
    Type
      eph = Record
              de : Array[0..4] Of Real;
              et : Array[0..4] Of Real;
              sd : Array[0..1] Of Real;
              rs : Array[0..1] Of Real;
            End;

    Var
      jahrbuch : File Of eph;
      coef : Array[1..12] Of eph;
      Tag, Monat, Jahr, i, n1, n2 : Word;
      B, l, C : Real;

      Function mod_400(x : Real) : Real;
      Begin
        While x > 400 Do x := x-400;
        While x < 0 Do x := x+400;
        mod_400 := x;
      End;


      Function arcsin(x : Real) : Real;
      Begin
        If Abs(x) = 1 Then arcsin := sgn(x)*Pi/2
        Else arcsin := ArcTan(x/Sqrt(1-x*x));
      End;

      Function arccos(x : Real) : Real;
      Begin
        If x = 0 Then arccos := Pi/2
        Else
          If x < 0 Then arccos := Pi+ArcTan(Sqrt(1-x*x)/x)
        Else arccos := ArcTan(Sqrt(1-x*x)/x);
      End;

      Function deg_rad(x : Real) : Real;
      (* Eingabe: Dezimalaltgrad
         Ausgabe: Rad
      *)
      Begin
        deg_rad := x/180*Pi;
      End;

      Function rad_deg(x : Real) : Real;
      (* Eingabe: Rad
         Ausgabe: Dezimalaltgrad
      *)
      Begin
        rad_deg := x*180/Pi;
      End;

      Function lies_jahrbuch : Boolean;
      Var
        i : Integer;
        Name : String[64];
        jahrbuch : File Of eph;
      Begin
        lies_jahrbuch := False;
        Str(Azi1.Datum:6:0, Name);
        Name := Copy(Name, 5, 2);
        Name := 'SONNE.'+Name;
  {$I-}
        Assign(jahrbuch, Name);
        Reset(jahrbuch);
  {$I+}
        If IoResult <> 0 Then Exit;
        For i := 1 To 12 Do Read(jahrbuch, coef[i]);
        Close(jahrbuch);
        lies_jahrbuch := True;
      End;

      Procedure interpoliere(Var Dec, eth, sdm, rst : Real; Tag, mon : Word; MEZ : Real);
      Var x : Real;
      Begin
        x := (Tag+(MEZ-1)/24.0)/32.0;
        With coef[mon] Do
        Begin
          Dec := (((de[4]*x+de[3])*x+de[2])*x+de[1])*x+de[0];
          eth := (((et[4]*x+et[3])*x+et[2])*x+et[1])*x+et[0];
          sdm := sd[1]*x+sd[0];
          rst := rs[1]*x+rs[0];
        End;
      End;

      Function Richtung(mon, Tag : Word; MEZ, B, l : Real; Rand : Char) : Real;
      Var Dec, eth, sdm, dy, DX, T, lha, rst, z : Real;
      Begin
        interpoliere(Dec, eth, sdm, rst, Tag, mon, MEZ);
        Dec := deg_rad(Dec); sdm := deg_rad(sdm);
        lha := deg_rad(15*((MEZ-1)+eth))+l;
        dy := Sin(lha);
        DX := Sin(B)*Cos(lha)-Cos(B)*Sin(Dec)/Cos(Dec);
        R_P(dy, DX);
        T := dy+Pi;
        z := arccos(Sin(B)*Sin(Dec)+Cos(B)*Cos(Dec)*Cos(lha));
        DX := arcsin(Sin(sdm)/Sin(z));
        Case Rand Of
          'L' : T := T-DX;
          'R' : T := T+DX;
        End;
        Richtung := T*200/Pi;
      End;

    Begin
      If Not lies_jahrbuch Then
      Begin
        Siren;
        melde('Jahrbuch fehlt');
        Delay(1000);
        Exit;
      End;
      Tag := Trunc(Azi1.Datum/1E4);
      Jahr := Trunc(Frac(Azi1.Datum/100)*100+0.5);
      Monat := Trunc((Azi1.Datum-Tag*1E4-Jahr)/100);
      If Azi1.LS <> 0 Then l := hms_h(Azi1.LS)*Pi/180
      Else
        If Azi1.LZ <> 0 Then l := hms_h(Azi1.LZ)*Pi/180
      Else l := 0;
      If Azi1.BS <> 0 Then
      Begin
        B := hms_h(Azi1.BS)*Pi/180;
        C := Azi1.cS;
      End
      Else
        If Azi1.BZ <> 0 Then
        Begin
          B := hms_h(Azi1.BZ)*Pi/180;
          C := Azi1.cZ;
        End
      Else
      Begin
        B := 0; C := 0;
      End;
      n1 := 0; n2 := 0; Azi1.t1 := 0; Azi1.t2 := 0;
      For i := 1 To 5 Do
      Begin
        If Azi3[1].RH[i].Uhr > 0 Then
        Begin
          Azi3[1].RH[i].ti := mod_400(Azi3[1].RZ-Azi3[1].RH[i].Ri-C+
                                      Richtung(Monat, Tag, Azi3[1].RH[i].MEZ, B, l, Azi3[1].RH[i].Rand));
          write_screen_real(37, i+11, 8, 4, Azi3[1].RH[i].ti, Yellow, Black);
          Inc(n1);
          Azi1.t1 := Azi1.t1+Azi3[1].RH[i].ti;
        End
        Else
        Begin
          Azi3[1].RH[i].ti := 0;
          write_screen_real(37, i+11, 8, 4, Azi3[1].RH[i].ti, Yellow, Black);
        End;

        If Azi3[2].RH[i].Uhr > 0 Then
        Begin
          Azi3[2].RH[i].ti := mod_400(Azi3[2].RZ-Azi3[2].RH[i].Ri-C+
                                      Richtung(Monat, Tag, Azi3[2].RH[i].MEZ, B, l, Azi3[2].RH[i].Rand));
          write_screen_real(37, i+17, 8, 4, Azi3[2].RH[i].ti, Yellow, Black);
          Inc(n2);
          Azi1.t2 := Azi1.t2+Azi3[2].RH[i].ti;
        End
        Else
        Begin
          Azi3[2].RH[i].ti := 0;
          write_screen_real(37, i+17, 8, 4, Azi3[2].RH[i].ti, Yellow, Black);
        End;
      End;
      If n1 > 0 Then Azi1.t1 := Azi1.t1/n1;
      If n2 > 0 Then Azi1.t2 := Azi1.t2/n2;
      If (n1 > 0) And (n2 > 0) Then Azi1.tm := (Azi1.t1+Azi1.t2)/2
      Else If n1 > 0 Then Azi1.tm := Azi1.t1 Else Azi1.tm := Azi1.t2;
      write_screen_real(37, 17, 8, 4, Azi1.t1, Yellow, Black);
      write_screen_real(37, 23, 8, 4, Azi1.t2, Yellow, Black);
      zeig_felder(55, 55);

      For i := 1 To 5 Do
      Begin
        If Azi3[1].RH[i].Uhr > 0 Then
          Azi3[1].RH[i].v := Azi1.t1-Azi3[1].RH[i].ti
        Else
          Azi3[1].RH[i].v := 0;

        If Azi3[2].RH[i].Uhr > 0 Then
          Azi3[2].RH[i].v := Azi1.t2-Azi3[2].RH[i].ti
        Else
          Azi3[2].RH[i].v := 0;

      End;
      For i := 1 To 5 Do
      Begin
        write_screen_real(47, i+11, 7, 2, Azi3[1].RH[i].v*1E3, Yellow, Black);
        write_screen_real(47, i+17, 7, 2, Azi3[2].RH[i].v*1E3, Yellow, Black);
      End;
    End;

    Procedure Streckenreduktion;
    Const Rad = 6381438.5;
    Var zd, d, YR, YG, HM, dH : Real;

    Begin
      If (Pos(GeraeteTyp[Azi2.MG], 'HPDIGM') > 0) And (Azi2.d > 0) Then
      Begin
        zd := Azi2.z+arcsin(((Azi2.E-Azi2.r)-(Azi2.F-Azi2.T)-
                             0.68166E-7*Sqr(Azi2.d+GerKonst[Azi2.MG].C))*
                            Sin(Azi2.z*Pi/200)/(Azi2.d+GerKonst[Azi2.MG].C))*200/Pi;
        d := Azi2.d+ATM(Azi2.d, Azi2.Temp, Azi2.Druck, Azi2.MG);
        YG := Azi1.YS; YR := Azi1.YZ;
        If (Azi1.YZ = 0) And (Azi1.YS > 0) Then YR := Azi1.YS;
        If (Azi1.YS = 0) And (Azi1.YZ > 0) Then YG := Azi1.YZ;
        If (YG = 0) And (YR = 0) Then YG := 500000;
        YG := YG-3500000.0; YR := YR-3500000.0;
        dH := d*Cos(zd*Pi/200);
        If Azi1.HS > 0 Then HM := Azi1.HS+(Azi2.E+dH)/2
        Else HM := Azi1.HZ+(Azi2.r-dH)/2;
        If (Azi1.HS = 0) And (Azi1.HZ = 0) Then HM := 200;
        Azi2.S := (d+GerKonst[Azi2.MG].C)*Sin(zd*Pi/200)*(1.0-HM/Rad)*(1.0+(YG*YG+YG*YR+YR*YR)/6.0/Rad/Rad);
      End;

      If Azi2.z > 0 Then
        Azi2.dH := (Azi2.S)*Cos(Azi2.z*Pi/200)/Sin(Azi2.z*Pi/200)+
        Sqr(Azi2.S)*0.68166E-7+Azi2.F-Azi2.T
      Else Azi2.dH := 0;

      zeig_felder(55, 58);
    End;

    Procedure Polarpunkt;
    Begin
      If Azi2.S > 0 Then
        If JaNein('PZ rechnen') Then
        Begin
          Azi1.YZ := Azi1.YS+Azi2.S*Sin(Azi1.tm/200*Pi);
          Azi1.XZ := Azi1.XS+Azi2.S*Cos(Azi1.tm/200*Pi);
          Azi1.HZ := Azi1.HS+Azi2.dH;
          gauss_geografisch(Azi1.YZ, Azi1.XZ, Azi1.LZ, Azi1.BZ, Azi1.cZ);
          Azi1.LZ := h_hms(Azi1.LZ);
          Azi1.BZ := h_hms(Azi1.BZ);
          Azi1.cZ := Azi1.cZ;
        End
        Else
          If JaNein('oder PS rechnen') Then
          Begin
            Azi1.YS := Azi1.YZ+Azi2.S*Sin((Azi1.tm-200)/200*Pi);
            Azi1.XS := Azi1.XZ+Azi2.S*Cos((Azi1.tm-200)/200*Pi);
            Azi1.HS := Azi1.HZ-Azi2.dH;
            gauss_geografisch(Azi1.YS, Azi1.XS, Azi1.LS, Azi1.BS, Azi1.cS);
            Azi1.LS := h_hms(Azi1.LS);
            Azi1.BS := h_hms(Azi1.BS);
            Azi1.cS := Azi1.cS;
          End;
    End;

    Procedure schreib_Azimut;
    Const Diskettenfehler = 'Disketten-Schreibfehler!';
    Var i : Word;
      msg : String[12];
      rec : Word;

    Begin
      If merk_rec = 0 Then rec := FileSize(Datei) Else rec := merk_rec;
      (*  Punktzeiger aktualisieren *)
      i := 0;
      Repeat
        Inc(i);
      Until (PunktZeiger[i].rec = rec) Or (i = Succ(stationen));
      If i = Succ(stationen) Then stationen := Succ(stationen);
      PunktZeiger[i].pkt := Azi1.Ps;
      PunktZeiger[i].rec := rec;
      Seek(ZeigerFile, i);
  (*$I-*)
      Write(ZeigerFile, PunktZeiger[i]);
  (*$I+*)
      If IoResult > 0 Then
      Begin
        melde(Diskettenfehler); Siren;
        Repeat Until KeyPressed; Exit;
      End;
      Seek(Datei, rec);
      Buffer.art := Azimut1; Buffer.Az1 := Azi1; Write(Datei, Buffer);
      Buffer.art := Azimut2; Buffer.Az2 := Azi2; Write(Datei, Buffer);
      Buffer.art := Azimut3; Buffer.Az3 := Azi3[1]; Write(Datei, Buffer);
      Buffer.art := Azimut3; Buffer.Az3 := Azi3[2]; Write(Datei, Buffer);
      melde('Daten gespeichert!'); Beep; warten(1);
      InitAzimut; merk_rec := 0;
      zeig_felder(1, max_Felder);
      Close(Datei);
      msk_inp := Projekt+'.BEO';
      Assign(Datei, msk_inp);
      Reset(Datei);
      Close(ZeigerFile);
      msk_inp := Projekt+'.PTR';
      Assign(ZeigerFile, msk_inp);
      Reset(ZeigerFile);
      merk_rec := 0;
    End;

  Begin
    ErstRichtung := 0;
    If merk_rec = 0 Then InitAzimut;
    Azimut_Maske;
    ZeigAzimut;
    if Janein('Interne Stoppuhr verwenden') then InternalSW:=True
    else InternalSW:=False;
    Repeat
      rev := feldinp(1, 1);
      Case rev Of
        F1 :
          Begin
            merk_rec := Standpunktwahl(msk_inp);
            If merk_rec > 0 Then
            Begin
              Seek(Datei, merk_rec);
              Read(Datei, Buffer);
              If Buffer.art <> Azimut1 Then
              Begin
                Beep;
                melde('Keine Azimutbeobachtung');
                Delay(2000);
                melde('');
                merk_rec := 0;
              End
              Else
              Begin
                Azi1 := Buffer.Az1;
                Read(Datei, Buffer);
                Azi2 := Buffer.Az2;
                Read(Datei, Buffer);
                Azi3[1] := Buffer.Az3;
                Read(Datei, Buffer);
                Azi3[2] := Buffer.Az3;
                ZeigAzimut;
              End;
            End;
            Rev:=F1;
          End;
        F2 :
          Begin
            rev := feldinp(1, 22);
            Koordinatenumformung;
            rev := feldinp(59, 62);
            rev := feldinp(68, 70);
            zeig_felder(9, 14);
            zeig_felder(59, 70);
            Rev:=F2;
          End;
        F3 :
          Begin
            MessMode := #0;
            Repeat
              melde('Messen: (S)onnenazimut, (Z)enitwinkel, (E)ntfernung ? ');
              MessMode := Readkey;
              MessMode := Upcase(MessMode);
            Until MessMode In [#27, 'S', 'Z', 'E'];
            Case MessMode Of
              'S' : Begin
                      melde('Sonnenazimutmessung');
                      rev := feldinp(21, 54);
                      If T2000_Flag Then T2000_aus;
                      Zeitreduktion;
                      Azimutberechnung;
                      ZeigAzimut;
                    End;
              'Z' : Begin
                      melde('Zenitwinkelmessung');
                      rev := feldinp(64, 67);
                      If Not test_zenit Then
                      Begin
                        Siren;
                        melde('Fehler in Zenitdistanz!');
                        Delay(1000);
                        melde('');
                        rev := RET;
                      End
                      Else zeig_felder(63, 63);
                      If T2000_Flag Then T2000_aus;
                    End;
              'E' : Begin
                      melde('Entfernungsmessung');
                      rev := feldinp(68, 70);
                      rev := feldinp(56, 57);
                      If T2000_Flag Then T2000_aus;
                      Streckenreduktion;
                    End;
            End;
            MessMode := #0;
            melde('');
            rev:=F3;
          End;
        F5 :
          Begin
            Zeitreduktion;
            Azimutberechnung;
            Streckenreduktion;
            Polarpunkt;
            Koordinatenumformung;
            ZeigAzimut;
            Rev:=F5;
          End;
        F6 :
          Begin
            schreib_Azimut;
            Exit;
          End;
      End;
    Until rev = ESC;
    If (merk_rec = 0) And ((Azi1.Ps <> '') or (Azi1.PZ<>'')) Then
            If JaNein('Daten gehen verloren! Speichern') Then schreib_Azimut;
  End;

  Procedure Sonnenpolynom;
  Type
    EphTyp =
    Array[1..12] Of
      Record
        de : Array[0..4] Of Real;
        et : Array[0..4] Of Real;
        sd : Array[0..1] Of Real;
        rs : Array[0..1] Of Real;
      End;

  Var
    coef : EphTyp;
    jahrbuch : File Of EphTyp;
    i, j, Jahr, Monat : Integer;

    Procedure InitJahrbuch;
    Var i, j : Word;
    Begin
      For i := 1 To 12 Do
        With coef[i] Do
        Begin
          For j := 0 To 4 Do
          Begin
            de[j] := 0; et[j] := 0;
          End;
          For j := 0 To 1 Do
          Begin
            sd[j] := 0; rs[j] := 0;
          End;
        End;
    End;

    Procedure Summen;
    Var j : Word;
      SumET, SumDE : Real;
    Begin
      SumDE := 0; SumET := 0;
      For j := 0 To 4 Do
      Begin
        SumET := SumET+coef[Monat].et[j];
        SumDE := SumDE+coef[Monat].de[j];
      End;
      msk_val := SumDE; MaskIO(msk_par[17]);
      msk_val := SumET; MaskIO(msk_par[18]);
    End;

    Procedure zeig_Monat;
    Var i : Word;
    Begin
      For i := 3 To 7 Do
      Begin
        msk_val := coef[Monat].de[i-3];
        zeig_felder(i, i);
      End;
      For i := 8 To 12 Do
      Begin
        msk_val := coef[Monat].et[i-8];
        zeig_felder(i, i);
      End;
      For i := 13 To 14 Do
      Begin
        msk_val := coef[Monat].sd[i-13];
        zeig_felder(i, i);
      End;
      For i := 15 To 16 Do
      Begin
        msk_val := coef[Monat].rs[i-15];
        zeig_felder(i, i);
      End;
      Summen;
    End;

    Procedure Erfassen;
    Label 00;
    Var i, j : Word;
    Begin
      Monat := 1;
      Repeat
00:     msk_val := Monat;
        MaskIO(msk_par[2]);
        Case msk_rev Of
          ESC, Up : Exit;
          RET : Monat := Trunc(msk_val);
          PgUp : Begin
                   If Monat > 1 Then Dec(Monat);
                   zeig_Monat;
                   GoTo 00;
                 End;
          PgDown : Begin
                     If Monat < 12 Then Inc(Monat) Else Monat := 1;
                     zeig_Monat;
                     GoTo 00;
                   End;
        End;
        msk_val := 0;
        i := 0;
        zeig_Monat;
        Repeat
          msk_val := coef[Monat].de[i];
          MaskIO(msk_par[i+3]);
          Case msk_rev Of
            RET : Begin
                    coef[Monat].de[i] := msk_val; Inc(i);
                  End;
            Up : Begin
                   msk_val := coef[Monat].de[i];
                   zeig_felder(i+3, i+3);
                   If i > 0 Then Dec(i);
                 End;
            Down : Begin
                     msk_val := coef[Monat].de[i];
                     zeig_felder(i+3, i+3);
                     If i < 5 Then Inc(i);
                   End;
          End;
          Summen;
        Until (i = 5) Or (msk_rev = ESC);
        i := 0;
        Repeat
          msk_val := coef[Monat].et[i];
          MaskIO(msk_par[i+8]);
          Case msk_rev Of
            RET : Begin
                    coef[Monat].et[i] := msk_val; Inc(i);
                  End;
            Up : Begin
                   msk_val := coef[Monat].et[i];
                   zeig_felder(i+8, i+8);
                   If i > 0 Then Dec(i);
                 End;
            Down : Begin
                     msk_val := coef[Monat].de[i];
                     zeig_felder(i+8, i+8);
                     If i < 5 Then Inc(i);
                   End;
          End;
          Summen;
        Until (i = 5) Or (msk_rev = ESC);
        i := 0;
        Repeat
          msk_val := coef[Monat].sd[i];
          MaskIO(msk_par[i+13]);
          Case msk_rev Of
            RET : Begin
                    coef[Monat].sd[i] := msk_val; Inc(i);
                  End;
            Up : Begin
                   msk_val := coef[Monat].sd[i];
                   zeig_felder(i+13, i+13);
                   If i > 0 Then Dec(i);
                 End;
            Down : Begin
                     msk_val := coef[Monat].sd[i];
                     zeig_felder(i+13, i+13);
                     If i < 2 Then Inc(i);
                   End;
          End;
        Until (i = 2) Or (msk_rev = ESC);
        i := 0;
        Repeat
          msk_val := coef[Monat].rs[i];
          MaskIO(msk_par[i+15]);
          Case msk_rev Of
            RET : Begin
                    coef[Monat].rs[i] := msk_val; Inc(i);
                  End;
            Up : Begin
                   msk_val := coef[Monat].rs[i];
                   zeig_felder(i+15, i+15);
                   If i > 0 Then Dec(i);
                 End;
            Down : Begin
                     msk_val := coef[Monat].sd[i];
                     zeig_felder(i+15, i+15);
                     If i < 2 Then Inc(i);
                   End;
          End;
        Until (i = 2) Or (msk_rev = ESC);
      Until False;

    End;

  Begin
    Satz_Art := Polynom;
    Jahr := 0; Monat := 1;
    InitJahrbuch;
    Polynom_Maske;
    Repeat
      msk_val := Jahr;
      MaskIO(msk_par[1]);
      Case msk_rev Of
        F1, RET :
          Begin
            InitJahrbuch;
            Jahr := Trunc(msk_val);
            msk_inp := Copy(msk_inp, 3, 2);
            While msk_inp[1] = #32 Do Delete(msk_inp, 1, 1);
            Assign(jahrbuch, 'SONNE.'+msk_inp);
        {$I-}
            Reset(jahrbuch);
            If IoResult > 0 Then
            Begin
              Rewrite(jahrbuch);
              Write(jahrbuch, coef);
            End;
        {$I+}
            Seek(jahrbuch, 0);
            Read(jahrbuch, coef);
            msk_val := 0; Monat := 1;
            zeig_Monat;
            Erfassen;
          End;
        ESC :
          Begin
            If JaNein('Koeffizienten speichern') Then
            Begin
              Seek(jahrbuch, 0);
              Write(jahrbuch, coef);
            End;
        {$I-}
            Close(jahrbuch);
            If IoResult = 0 Then Begin End;
        {$I+}
            Satz_Art := Station;
            Exit;
          End;
      End;
    Until False;

  End;

  Procedure SetSystemClock;
  Label 00, 01, 02, 03, 04;
  Var prm : msk_par_typ;
    regs : registers;
    Ch : Char;
    hh, mm, ss : Byte;
  Begin
    ClrScr; Richtung := 0;
    WriteLn('META                       Systemuhr stellen');
    WriteLn(ConstStr(78, #205));
    WriteLn;
    WriteLn('Datum:   Tag Mon Jahr         Uhrzeit: HH  mm  ss');
00: regs.ah := $2a;
    MsDos(regs);
    prm.io := 'I'; prm.opt := 'P'; prm.x := 10; prm.y := 5; prm.l := 2;
    prm.komma := 0;
    msk_val := regs.dl;
    MaskIO(prm);
    If msk_rev = ESC Then Exit;
    regs.dl := Trunc(msk_val);

01: prm.io := 'I'; prm.opt := 'P'; prm.x := 14; prm.y := 5; prm.l := 2;
    prm.komma := 0;
    msk_val := regs.dH;
    MaskIO(prm);
    Case msk_rev Of
      ESC : Exit;
      Up : GoTo 00;
    End;
    regs.dH := Trunc(msk_val);

02: prm.io := 'I'; prm.opt := 'P'; prm.x := 18; prm.y := 5; prm.l := 4;
    prm.komma := 0;
    msk_val := regs.cx;
    MaskIO(prm);
    Case msk_rev Of
      ESC : Exit;
      Up : GoTo 01;
    End;
    If (msk_val < 1980) Or (msk_val > 2099) Then GoTo 02;
    regs.DX := Trunc(msk_val);
    regs.ah := $2b; MsDos(regs);

    regs.ah := $2c;
    MsDos(regs);
03: prm.io := 'I'; prm.opt := 'P'; prm.x := 40; prm.y := 5; prm.l := 2;
    prm.komma := 0;
    msk_val := regs.Ch;
    MaskIO(prm);
    Case msk_rev Of
      ESC : Exit;
      Up : GoTo 00;
    End;

    regs.Ch := Trunc(msk_val);

04: prm.io := 'I'; prm.opt := 'P'; prm.x := 44; prm.y := 5; prm.l := 2;
    prm.komma := 0;
    msk_val := regs.cl;
    MaskIO(prm);
    Case msk_rev Of
      ESC : Exit;
      Up : GoTo 03;
    End;
    regs.cl := Trunc(msk_val);

    prm.io := 'I'; prm.opt := 'P'; prm.x := 48; prm.y := 5; prm.l := 2;
    prm.komma := 0;
    msk_val := regs.dH;
    MaskIO(prm);
    Case msk_rev Of
      ESC : Exit;
      Up : GoTo 04;
    End;
    regs.dH := Trunc(msk_val);
    regs.dl := 0;
    hh := regs.Ch; mm := regs.cl; ss := regs.dH;
    melde('Uhrzeit durch Tastendruck einstellen.');
    Repeat Until KeyPressed;
    regs.Ch := 16*(regs.Ch Div 10)+(regs.Ch Mod 10);
    regs.cl := 16*(regs.cl Div 10)+(regs.cl Mod 10);
    regs.dH := 16*(regs.dH Div 10)+(regs.dH Mod 10);
    regs.ah := 3; Intr($1a, regs);
    regs.Ch := hh; regs.cl := mm; regs.dH := ss; regs.dl := 0;
    regs.ah := $2d; MsDos(regs);
    While KeyPressed Do Ch := Readkey;
  End;

Begin
End.
