unit METASW;
{F+}
interface
uses dos,crt;
var
  zaehler:word;                   (* Zaehler in META SW *)
  Hsec:Longint;                   (* METASW Zeitvariable mit Zeit in 1/100 sec *)

procedure InitSW;
procedure CloseSW;
function StopSW:real;

implementation
const
  OldTimerInt = 102;              (* Interrupt vektor alter Timer in METASW *)

procedure StelleTimerEin(Rout:Pointer;Freq:Word);
var
  Izaehler:word;
  OldV:Pointer;
begin
  Inline($FA);
  Izaehler:=1193180 DIV Freq;
  Port[$43]:=$36;
  port[$40]:=lo(IZaehler);
  port[$40]:=hi(IZaehler);
  getIntVec(8,OldV);
  SetIntVec(OldTimerInt,OldV);
  setIntVec(8,Rout);
  inline($FB);
end;

procedure CloseSW;
var
  OldV:Pointer;
begin
  inline($FA);
  port[$43]:=$36;
  port[$40]:=0;
  port[$40]:=0;
  getIntVec(OldTimerInt,OldV);
  setIntVec(8,OldV);
  inline($FB);
end;

procedure NeuerTimer;Interrupt;
var R:Registers;
begin
  dec(Zaehler);
  if Zaehler=0 then
  begin
    intr(OldTimerInt,R);
    Zaehler:=100 div 18;
  end
  else port[$20]:=$20;
  inc(Hsec);
end;

function hms_h(x:real):real;
    (* Eingabe: Grad.MinutenSekunden
       Ausgabe: Dezimalaltgrad
    *)
var y:real;
    minus:boolean;
begin
   minus:=x<0;x:=abs(x);
   y:=trunc(x);x:=(x-y)*100;
   y:=y+trunc(x)/60;x:=(x-trunc(x))*100;
   y:=y+x/3600;
   if minus then hms_h:=-y else hms_h:=y;
end;

function h_hms(x:real):real;
    (* Eingabe: Dezimalaltgrad
       Ausgabe: Grad.MinutenSekunden
    *)
var h,m,s:real;
    minus:boolean;
begin
  minus:=x<0;x:=abs(x);
  h:=int(x);x:=frac(x)*60;
  m:=int(x);s:=frac(x)*60;
  if trunc(s)>=60 then
  begin
     m:=m+1;s:=s-60;
  end;
  if trunc(m)>=60 then
  begin
    h:=h+1;m:=m-60;
  end;
  h:=h+m/100+s/10000;
  if minus then h_hms:=-h else h_hms:=h;
end;

procedure InitSW;
var h,m,s,hs:word;
begin
  Zaehler:=1;
  stelleTimerEin(@neuerTimer,100);
  GetTime(h,m,s,hs);
  Hsec:=trunc(hs+(s+m*60+h*3600.0)*100.0);
end;

function StopSW:real;
var
  ch:Char;
  x:real;
begin
  repeat until keypressed;
  StopSW:=h_hms(Hsec/360000.0);
  while keypressed do ch:=Readkey;
end;

begin
end.